using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Globalization;
using System.Reflection;
using System.Text;
using System.Transactions;

using Produmex.Foundation;
using Produmex.Foundation.Barcode;
using Produmex.Foundation.Data;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Data.SqlClient;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.GS1;
using Produmex.Foundation.Messages;
using Produmex.Foundation.SlimScreen;
using Produmex.Foundation.SlimScreen.Interfaces;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.DataObjects;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.KnownDataSets;
using Produmex.Foundation.SlimScreen.WinGui;
using Produmex.Foundation.Workflows;
using Produmex.Foundation.Workflows.Parameters;
using Produmex.Foundation.Wwf.Sbo;
using Produmex.Foundation.Wwf.Sbo.DataObjects;
using Produmex.Foundation.Wwf.Sbo.LocalServices;

using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.Reports;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.DataObjects;
using Produmex.Sbo.Logex.Data.Devices;
using Produmex.Sbo.Logex.Data.Generators.BatchNumberGenerators;
using Produmex.Sbo.Logex.Data.Generators.PackingController;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Data.ViewObjects.Definitions.Views;
using Produmex.Foundation.Data.Sbo.DataObjects;
using Produmex.Foundation.Data.DbClient;

namespace Produmex.Sbo.Logex.WorkflowScripts
{
    /// <summary>
    /// Reception
    /// </summary>
    public class WorkflowScript_ReceptionScriptLenL : WorkflowInstanceScriptBase
    {
        /// <summary>
        /// Definitions
        /// </summary>
        private static class Definitions
        {
            /// <summary>
            /// The separator for separating strings values
            /// </summary>
            public const string SEPARATOR = ", ";
        }


        // Input parameters
        public ReadOnlyBinder<CultureInfo> DefaultCultureInfo;
        public ReadOnlyBinder<PmxOseCompany> PmxOseCompany;

        private CultureInfo current_DefaultCultureInfo
        {
            get { return DefaultCultureInfo.Get(); }
        }

        private PmxOseCompany currentPmxOseCompany
        {
            get { return PmxOseCompany.Get(); }
        }

        private WorkflowInstanceBase m_printItemLabelFlow;
        private bool m_printItemLabelFlow_BackRequested = false;

        private string m_printItemLabelFlow_LocationCode;
        private string m_printItemLabelFlow_NeededItemCode;
        private string m_printItemLabelFlow_NeededBatchNumber;
        private DateTime? m_printItemLabelFlow_NeededBestBeforeDate;
        private int? m_printItemLabelFlow_NeededNrOfLabels;



        //Subflows
        WorkflowInstanceBase m_enterQuantitySubFlow;

        protected bool m_subFlowBackRequested;
        protected Collection<string> m_subFlowListOfSerialNumbers;
        protected double m_subFlowQuantity;



        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);


        #region Constructors

        public WorkflowScript_ReceptionScriptLenL(WorkflowInstanceBase parent, WorkflowInstanceFactory factory)
            : base(parent, factory)
        {
            m_enterQuantitySubFlow = this.Create("EnterQuantityScript");

        }

        #endregion

        #region WorkflowInstanceScriptBase Members

        /// <summary>
        /// Executes this instance.
        /// </summary>
        protected override void Execute()
        {
            // Parameters in scope
            Session session = GetScopeParameter("Session") as Session;
            ISboProviderService sboProviderService = GetScopeParameter("<WwfService>ISboService") as ISboProviderService;

            string initialErrorKey = null;
            string deviceID = session.DeviceInstanceId;
            SboUserInfo userInfo = sboProviderService.GetCurrentUser();
            Message msg = null;
            string query = null;
            PmxOseWarehouseInfo whsInfo = null;
            DataSet dsDocks = null;
            string currentDockCode = null;
            DataSet dsPurchaseOrders = null;
            int? purchaseOrderDocEntry = null;
            int? purchaseOrderDocNum = null;
            string filterGTIN = null;
            string cardCode = null;
            string filterButtonKey = null;
            DataSet dsSuppliers = null;
            BarcodeContainer barcode = null;
            string supplierPalletNumber = null;
            int batchReceivingNumber = 1;
            string[] buttonKeys = null;
            string titleKey = null;
            string[] allowedButtonsForLabelScreen = null;
            string SSCC = null;
            int? luid = null;
            string scannedSSCC = null;
            //BarcodeContainer productBarCode = null;
            string itemCode = null;
            string itemDescription = null;
            PmxItemInfo itemInfo = null;
            string gtin = null;
            DataSet dsItems = null;
            Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();
            string logisticCarrierCode = null;
            DataSet dsLogisticCarriers = null;
            double stillToReceive = 0;
            LogisticUnitGoodsReceipt currentLogUnit = null;
            string batchNumber = null;
            string secondBatchNumber = null;
            DateTime? bestBeforeDate = null;
            double quantity = 0;
            GeneratedBatchNumberReception generatedBatch1Info = null;
            GeneratedBatchNumberReception generatedBatch2Info = null;
            string tempBatchNumber = null;
            LogisticUnitItemGoodReceipt currentLogisticCarrier = null;
            DataSet dsExistingBatch = null;
            Collection<ItemTransactionalPackagingTypeInfo> currentListOfTransactionalPackagingTypeInfos;
            Collection<PackagingTypeInfo> listOfPackagingTypeInfosForScreen = null;
            int numberOfItemLabels = 0;
            double initialQuantity = 0;
            double maxQuantity = 0;
            string supplierRef = null;
            bool needToEnterSupplierPalletNumber = false;
            KeyValuePair<Collection<DocumentRef>, Collection<int>> listOfGeneratedDocEntry = new KeyValuePair<Collection<DocumentRef>, Collection<int>>();
            int numberOfReports = 0;
            bool receiveAllItemsOnOnePurchaseDelivery = false;
            double? numberOfItemsInPurchaseUnit = null;
            string[] allowedButtonsIdentifyProductScreen = null;
            bool goBack = false;
            DataSet dsCheckItems = null;
            DataSet dsItemsNonDistinct = null;
            DataSet dsSSCC = null;
            bool gotoReceiveItem = false;
            ToolBarButtons toolBarButtons = ToolBarButtons.Back;
            Collection<string> listOfSerialNumbers = null;
            bool autoSelectPO = false;

            whsInfo = sboProviderService.InvokeMethodWithDbConnection<PmxOseWarehouseInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxOseWarehouseInfo>(ExecuteGetPmxWarehouseCode), deviceID);

            receiveAllItemsOnOnePurchaseDelivery = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteGetReceiveAllItemsOnOnePurchaseDelivery));


            //initialize sub flows
            m_printItemLabelFlow = Create("PrintItemLabelScript");
            m_printItemLabelFlow.BindParameters(
                new ReadOnlyBinder<CultureInfo>("DefaultCultureInfo", this, "current_DefaultCultureInfo"),
                new ReadOnlyBinder<PmxOseCompany>("PmxOseCompany", this, "currentPmxOseCompany"),
                new ReadOnlyBinder<string>("LocationCode", this, "m_printItemLabelFlow_LocationCode"),
                new ReadOnlyBinder<string>("NeededItemCode", this, "m_printItemLabelFlow_NeededItemCode"),
                new ReadOnlyBinder<string>("NeededBatchNumber", this, "m_printItemLabelFlow_NeededBatchNumber"),
                new ReadOnlyBinder<DateTime?>("NeededBestBeforeDate", this, "m_printItemLabelFlow_NeededBestBeforeDate"),
                new ReadOnlyBinder<int?>("NeededNrOfLabels", this, "m_printItemLabelFlow_NeededNrOfLabels"),
                new ReadWriteBinder<bool>("BackRequested", this, "m_printItemLabelFlow_BackRequested")
                );





        Step_SelectDock:

            #region SELECT DOCK

            // Get locations
            query = BuildQuery.GetCodeNameDockOrderByName(null, true, false, whsInfo.PmxWarehouseCode);
            dsDocks = sboProviderService.RunView(false, null, null, query);

            if (this.GetNumberOfRows(dsDocks) == 1)
            {
                currentDockCode = Convert.ToString(dsDocks.Tables[0].Rows[0][LocationDataSet.Columns.CODE.Name]);
                goto Step_SelectPOFilter;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectLocationScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", "MSG_TITLE_SELECT_LOCATION",
                "LocationDS", dsDocks
                ));

            msg = WaitForMessage();
            initialErrorKey = null;
            if (msg.Name.EndsWith(".LocationSelected"))
            {
                currentDockCode = ExtractParameter<string>(msg.Parameters, "locationCode");
                goto Step_SelectPOFilter;
            }

            if (msg.Name.EndsWith(".RefreshRequested"))
            {
                goto Step_SelectDock;
            }

            //back requested
            return;

            #endregion

        Step_SelectPOFilter:

            #region SELECT PO FILTER

            filterGTIN = null;
            filterButtonKey = null;
            cardCode = null;
            purchaseOrderDocEntry = null;
            autoSelectPO = false;

            buttonKeys = new string[4] { "MSG_BUTTON_PO_FILTER_EAN", "MSG_BUTTON_PO_FILTER_ORDER", "MSG_BUTTON_PO_FILTER_NO_PO", "MSG_BUTTON_PO_FILTER_AUTO_SELECT_ORDER" };

            toolBarButtons = ToolBarButtons.Stop | ToolBarButtons.Back;


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectButtonScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_PO_FILTER",
                    "AllowedButtons", buttonKeys,
                    "EnabledToolBarButtons", toolBarButtons
                    ));
            msg = WaitForMessage();
            initialErrorKey = null;
            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                filterButtonKey = ExtractParameter<string>(msg.Parameters, "buttonKey");

                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_EAN")
                {
                    goto Step_FilterOnEAN;
                }

                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_ORDER")
                {
                    goto Step_SelectOrder;
                }

                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_AUTO_SELECT_ORDER")
                {
                    autoSelectPO = true;
                }

                goto Step_SelectSupplier;
            }

            if (msg.Name.EndsWith(".BackRequested"))
            {
                goto Step_SelectDock;
            }

            if (msg.Name.EndsWith(".StopRequested"))
            {
                return;
            }

            #endregion

        Step_SelectSupplier:

            #region SELECT SUPPLIER

            cardCode = null;

            query = BuildQuery.GetSuppliersOrderByName();
            dsSuppliers = sboProviderService.RunView(false, null, null, query);

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.ISelectSupplierScreen),
                 DefaultCultureInfo.Get(), BuildParamCollection(
                 "InitialErrorKey", initialErrorKey,
                 "TitleKey", "MSG_TITLE_SELECT_SUPPLIER",
                 "SupplierDS", dsSuppliers
                 ));

            msg = WaitForMessage();
            initialErrorKey = null;
            if (msg.Name.EndsWith(".SupplierSelected"))
            {
                cardCode = ExtractParameter<string>(msg.Parameters, "supplierCode");

                goto Step_EnterSupplierReference;
            }

            goto Step_SelectPOFilter;

            #endregion

        Step_FilterOnEAN:

            #region FILTER ON EAN

            filterGTIN = null;


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyGS1DataScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SCAN_GS1_LABEL",
                    "ImageType", GS1ImageType.BoxImage));

            msg = WaitForMessage();
            // Reset latest error
            initialErrorKey = null;
            barcode = null;
            filterGTIN = null;

            if (msg.Name.EndsWith(".DataEntered"))
            {
                barcode = ExtractParameter<BarcodeContainer>(msg.Parameters, "data");

                //check if there is a product present
                if (barcode != null &&
                !string.IsNullOrEmpty(BarcodeHelper.GetProductIdentification(barcode)))
                {
                    filterGTIN = BarcodeHelper.GetProductIdentification(barcode);
                    goto Step_SelectOrder;

                }
                else
                {
                    initialErrorKey = "MSG_ERROR_NO_PRODUCT_ON_BARCODE";
                    goto Step_FilterOnEAN;
                }
            }
            else if (msg.Name.EndsWith(".BackRequested"))
            {
                goto Step_SelectPOFilter;
            }

            initialErrorKey = "MSG_ERROR_OPERATION_NOT_SUPPORTED";
            goto Step_FilterOnEAN;


            #endregion

        Step_SelectOrder:

            #region SELECT ORDER

            purchaseOrderDocEntry = null;
            purchaseOrderDocNum = null;
            query = BuildQuery.GetPOsOrderByPONumber(/*cardCode*/ null, filterGTIN, sboProviderService.GetDbTool());
            dsPurchaseOrders = sboProviderService.RunView(false, null, null, query);

            if (this.GetNumberOfRows(dsPurchaseOrders) == 0)
            {
                initialErrorKey = "MSG_ERROR_NO_PO_FOUND";
                goto Step_SelectPOFilter;
            }

            if (this.GetNumberOfRows(dsPurchaseOrders) == 1 &&
                filterButtonKey != "MSG_BUTTON_PO_FILTER_ORDER" &&
                !goBack)
            {
                //we find just one row, and we did not want to select it, so we autoselect it
                purchaseOrderDocEntry = Convert.ToInt32(dsPurchaseOrders.Tables[0].Rows[0][PurchaseOrderDataSet.Columns.PO_ID.Name]);
                cardCode = Convert.ToString(dsPurchaseOrders.Tables[0].Rows[0][PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name]);
                purchaseOrderDocNum = Convertor.ConvertToInt32Nullable(dsPurchaseOrders.Tables[0].Rows[0][PurchaseOrderDataSet.Columns.PO_NUMBER.Name]);
                goto Step_EnterSupplierReference;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.ISelectPOScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", "MSG_TITLE_SELECT_PO",
                "PODS", dsPurchaseOrders
                ));

            msg = WaitForMessage();
            goBack = false;
            initialErrorKey = null;
            if (msg.Name.EndsWith(".POSelected"))
            {
                purchaseOrderDocEntry = ExtractParameter<int>(msg.Parameters, "docEntry");

                DataRow[] rows = dsPurchaseOrders.Tables[0].Select(PurchaseOrderDataSet.Columns.PO_ID.Name + " = " + purchaseOrderDocEntry.Value.ToString());

                if (rows.Length > 0)
                {
                    cardCode = Convert.ToString(rows[0][PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name]);
                    purchaseOrderDocNum = Convertor.ConvertToInt32Nullable(rows[0][PurchaseOrderDataSet.Columns.PO_NUMBER.Name]);
                }

                goto Step_EnterSupplierReference;
            }

            //go back
            goto Step_SelectPOFilter;

            #endregion

        Step_EnterSupplierReference:

            #region ENTER SUPPLIER REFERENCE

            purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();

            supplierRef = null;

            if (PmxOseCompany.Get().GoodsReceiptRequiresSupplierRef)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterStringValueScreen),
                 DefaultCultureInfo.Get(), BuildParamCollection(
                     "InitialErrorKey", initialErrorKey,
                     "TitleKey", "MSG_TITLE_ENTER_SUPPLIER_REF",
                     "ForceDataEntry", true,
                     "ForceUppercase", true,
                     "AllowToGoBack", true,
                     "Information", "MSG_ENTER_SUPPLIER_REF_FOR_PO_DELIVERY"
                     ));
                msg = WaitForMessage();

                // reset error
                initialErrorKey = null;

                if (msg.Name.EndsWith(".StringEntered"))
                {
                    supplierRef = ExtractParameter<string>(msg.Parameters, "stringValue");
                    //goto Step_SelectLogisticCarrier;
                }
                else if (msg.Name.EndsWith(".BackRequested"))
                {
                    if (filterButtonKey == "MSG_BUTTON_PO_FILTER_NO_PO")
                    {
                        goto Step_SelectPOFilter;
                    }
                    else if (filterButtonKey == "MSG_BUTTON_PO_FILTER_EAN")
                    {
                        goto Step_FilterOnEAN;
                    }
                    else
                    {
                        goto Step_SelectOrder;
                    }
                }
            }

            needToEnterSupplierPalletNumber = sboProviderService.InvokeMethodWithDbConnection<bool>(true, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteNeedToEnterSupplierPalletNumber), cardCode);

            goto Step_AskBatchReceiving;


            #endregion

        Step_ShowMessageNextLogisticUnit:

            #region SHOW MESSAGE NEXT LOGISTIC UNIT

            // Inform the user the items are received
            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "MessageKey", "MSG_ENTER_NEXT_LOGISTIC_UNIT",
                    "ShowButton", true));
            WaitForMessage();

            goto Step_AskBatchReceiving;

            #endregion

        Step_AskBatchReceiving:

            #region ASK BATCH RECEIVING

            batchReceivingNumber = 1;
            barcode = null;
            buttonKeys = new string[2] { "MSG_BUTTON_BATCH_RECEIVING", "MSG_BUTTON_NO_BATCH_RECEIVING" };

            if (needToEnterSupplierPalletNumber ||
                autoSelectPO)
            {
                //we need to enter supplier pallet number, so do not ask for batch receiving, because it is not allowed!
                
                //goto Step_ScanLabelStart;
                goto Step_SelectLogisticCarrier;
            }

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectButtonScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_TASK",
                    "AllowedButtons", buttonKeys,
                    "ShowStopButton", false
                    ));
            msg = WaitForMessage();
            initialErrorKey = null;
            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                if (ExtractParameter<string>(msg.Parameters, "buttonKey") == "MSG_BUTTON_BATCH_RECEIVING")
                {
                    goto Step_EnterBatchReceiving;
                }
                else
                {
                    goto Step_ScanLabelStart;
                }
            }

            //go back
            goto Step_GoBack;


            #endregion

        Step_EnterBatchReceiving:

            #region ENTER BATCH RECEIVING

            batchReceivingNumber = 1;

            //ask for quantity
            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_BATCH_RECEIVING",
                    "InitialQuantity", 1,
                    "NumberOfDigitsAfterDecimal", 0,
                    "MaximumQuantity", -1,
                    "UOM", ""
                   ));
            msg = WaitForMessage();

            //clear data
            initialErrorKey = null;

            if (msg.Name.EndsWith(".QuantityEntered"))
            {
                batchReceivingNumber = Convert.ToInt32(ExtractParameter<double>(msg.Parameters, "quantity"));

                //goto Step_SelectLogisticCarrier;
                goto Step_ScanLabelStart;
            }

            goto Step_AskBatchReceiving;

            #endregion

        Step_ScanLabelStart:

            #region SCAN LABEL START

            titleKey = "MSG_TITLE_SCAN_GS1_LABEL";
            allowedButtonsForLabelScreen = new string[1] { "MSG_BUTTON_NO_LABEL" };
            barcode = null;
            currentLogUnit = new LogisticUnitGoodsReceipt();

            goto Step_ScanLabel;

            #endregion

        Step_ScanLabel:

            goto Step_CheckSSCC;

            #region SCAN LABEL


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyGS1DataScreen),
            DefaultCultureInfo.Get(), BuildParamCollection(
                "InitialErrorKey", initialErrorKey,
                "TitleKey", titleKey,
                "ImageType", GS1ImageType.PalletImage,
                "AllowedButtons", allowedButtonsForLabelScreen,
                "GS1DataObject", barcode == null ? null : barcode.GS1DataObject
                ));

            msg = WaitForMessage();
            // Reset latest error
            initialErrorKey = null;

            if (msg.Name.EndsWith(".DataEntered"))
            {
                barcode = ExtractParameter<BarcodeContainer>(msg.Parameters, "data");

                if (this.IsBatchNumberOnBarcode(barcode.GS1DataObject)
                    && this.IsSSCCOnBarcode(barcode.GS1DataObject)
                    && this.IsProductOnBarcode(barcode)
                    && this.IsBestBeforeDateOnBarcode(barcode.GS1DataObject))
                {
                    goto Step_CheckSSCC;
                }
                else
                {
                    titleKey = "MSG_TITLE_SCAN_NEXT_GS1_LABEL";
                    allowedButtonsForLabelScreen = new string[1] { "MSG_BUTTON_DONE" };
                    goto Step_ScanLabel;
                }

            }
            else if (msg.Name.EndsWith(".BackRequested"))
            {
                goto Step_GoBack;
            }
            else if (msg.Name.EndsWith(".ButtonClicked"))
            {
                goto Step_CheckSSCC;
            }

            initialErrorKey = "MSG_ERROR_OPERATION_NOT_SUPPORTED";
            goto Step_ScanLabel;


            #endregion

        Step_CheckSSCC:

            #region CHECK SSCC

            SSCC = null;
            scannedSSCC = null;
            luid = null;

            if (barcode != null &&
                barcode.GS1DataObject != null &&
                !string.IsNullOrEmpty(barcode.GS1DataObject.Sscc))
            {
                scannedSSCC = barcode.GS1DataObject.Sscc;

                //check if the scanned SSCC is valid
                if (sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteIsSSCCValid), scannedSSCC))
                {
                    SSCC = scannedSSCC;
                    int tempLUID = sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null, new DelegateWithPmxDbConnection<int>(ExecuteGetLUIDBySSCC), SSCC);
                    if (tempLUID > 0)
                    {
                        luid = tempLUID;
                    }
                    goto Step_SelectLogisticCarrier;
                }
                else
                {
                    //invalid
                    initialErrorKey = "MSG_ERROR_INVALID_SSCC";
                    goto Step_ScanLabelStart;
                }
            }

            goto Step_SelectLogisticCarrier;


            #endregion

        Step_SelectLogisticCarrier:

            #region SELECT LOGISTIC CARRIER

            logisticCarrierCode = null;
            currentLogisticCarrier = null;

            //set luid
            currentLogUnit.LogisticUnitId = luid;
            currentLogUnit.SSCC = SSCC;


            if (luid > 0 ||
                (this.IsLUOnBarcode(barcode) && itemInfo.IsLogisticUnit) ||
                (currentLogUnit != null && currentLogUnit.ItemsOnLogisticUnit.Count > 0))
            {
                //we do not need to add logistic carrier
                goto Step_EnterSupplierPalletNumber;
            }


            //ask for logistic carrier
			query = BuildQuery.GetLogisticCarriersOrderByName(false, true, sboProviderService.GetDbTool());
            dsLogisticCarriers = sboProviderService.RunView(false, null, null, query);

            if (this.GetNumberOfRows(dsLogisticCarriers) == 0)
            {
                //There are no logistic carriers, so we do not show screen
                logisticCarrierCode = null;
                goto Step_EnterSupplierPalletNumber;
            }


            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectProductScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_LOGISTIC_CARRIER",
                    "ProductDS", dsLogisticCarriers,
                    "ButtonKey", "MSG_BUTTON_NO_LOGISTIC_CARRIER"
                    ));
            msg = WaitForMessage();

            //clear data
            initialErrorKey = null;

            if (msg.Name.EndsWith(".ProductSelected"))
            {
                logisticCarrierCode = ExtractParameter<string>(msg.Parameters, "itemCode");

                //add to list

                currentLogisticCarrier = new LogisticUnitItemGoodReceipt();
                currentLogisticCarrier.BatchNumber1 = null;
                currentLogisticCarrier.BatchNumber2 = null;
                currentLogisticCarrier.BestBeforeDate = null;
                currentLogisticCarrier.ItemCode = logisticCarrierCode;
                currentLogisticCarrier.Quantity = 1;
                currentLogisticCarrier.IsLogisticCarrierForLogisticUnit = true;
                currentLogisticCarrier.IsLogisticCarrier = true;

                goto Step_EnterSupplierPalletNumber;
            }

            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                logisticCarrierCode = null;
                goto Step_EnterSupplierPalletNumber;
            }

            //go back
            goto Step_GoBack;



            #endregion

        Step_EnterSupplierPalletNumber:

            #region ENTER SUPPLIER PALLET NUMBER

            supplierPalletNumber = null;

            if (needToEnterSupplierPalletNumber)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterStringValueScreen),
                 DefaultCultureInfo.Get(), BuildParamCollection(
                     "InitialErrorKey", initialErrorKey,
                     "TitleKey", "MSG_TITLE_ENTER_SUPPLIER_PALLET_NUMBER",
                     "ForceDataEntry", true,
                     "ForceUppercase", true,
                     "AllowToGoBack", true,
                     "Information", "MSG_ENTER_SUPPLIER_PALLET_NUMBER"
                     ));
                msg = WaitForMessage();

                // reset error
                initialErrorKey = null;

                if (msg.Name.EndsWith(".StringEntered"))
                {
                    supplierPalletNumber = ExtractParameter<string>(msg.Parameters, "stringValue");
                    currentLogUnit.SupplierPalletNumber = supplierPalletNumber;
                    goto Step_IdentifyProduct;
                }
                else if (msg.Name.EndsWith(".BackRequested"))
                {
                    goto Step_GoBack;
                }
            }

            goto Step_IdentifyProduct;


            #endregion

        Step_GoBack:

            #region GO BACK

            //go back
            if ((currentLogUnit != null &&
                currentLogUnit.ItemsOnLogisticUnit.Count > 0))
            {
                //we want to go back, but we have some items in the list
                //ask user what to do
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_PRODUCTS_ON_LOGISTIC_UNIT_TO_RECEIVE",
                        "MessageKey", "MSG_QUESTION_PRODUCTS_ON_LIST_TO_RECEIVE"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    //receive the items
                    goto Step_ReceiveItems;
                }
            }

            if ((purchaseDeliveryNoteList != null &&
                purchaseDeliveryNoteList.Count > 0))
            {
                //we want to go back, but we have some items in the list
                //ask user what to do
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_PRODUCTS_ON_LIST_TO_RECEIVE",
                        "MessageKey", "MSG_QUESTION_PRODUCTS_ON_LIST_TO_RECEIVE"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    //there are pallets received, but user wants to go back, so we will receive them right now
                    goBack = true;

                    // Inform the user items are receiving
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", "MSG_RECEIVING_ALL_ITEMS",
                            "NoTranslationOfMessageKey", false,
                            "ShowButton", false));

                    goto Step_ReceiveItems;
                }
            }

            //clear data
            cardCode = null;

            if (filterButtonKey == "MSG_BUTTON_PO_FILTER_NO_PO")
            {
                goto Step_SelectPOFilter;
            }
            else if (filterButtonKey == "MSG_BUTTON_PO_FILTER_EAN")
            {
                goto Step_FilterOnEAN;
            }
            else
            {
                goBack = true;
                goto Step_SelectOrder;
            }

            #endregion

        Step_ClearDataBeforeNextItem:

            #region CLEAR DATA BEFORE NEXT ITEM

  
            barcode = null;

            goto Step_IdentifyProduct;

            #endregion

        Step_IdentifyProduct:

            #region IDENTIFY PRODUCT

            itemCode = null;
            itemDescription = null;
            itemInfo = null;
            numberOfItemsInPurchaseUnit = null;

            string tempGTIN = BarcodeHelper.GetProductIdentification(barcode);

            query = BuildQuery.GetCodeNameItemsOrderByName( null, tempGTIN, purchaseOrderDocEntry, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, true, sboProviderService.GetDbTool() );
            dsItems = sboProviderService.RunView(true, null, null, query);
			query = BuildQuery.GetCodeNameItemsOrderByName(null, tempGTIN, purchaseOrderDocEntry, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, sboProviderService.GetDbTool());
            dsItemsNonDistinct = sboProviderService.RunView(true, null, null, query);

            RemoveReceivedItems(purchaseDeliveryNoteList, dsItemsNonDistinct, currentLogUnit);

            //if (this.GetNumberOfRows(dsItems) == 1 &&
            //    !goBack)
            //{
            //    itemCode = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
            //    itemDescription = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;

            //    gtin = tempGTIN;

            //    if (dsItems.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME))
            //    {
            //        numberOfItemsInPurchaseUnit = Convert.ToDouble(dsItems.Tables[0].Rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
            //    }

            //    goto Step_GetItemInfo;
            //}

            if (this.GetNumberOfRows(dsItems) == 0)
            {
                //product not found
                initialErrorKey = "MSG_ERROR_INCORRECT_PRODUCT";
                //goto Step_ScanLabelStart;
                goto Step_GoBack;
            }

            if (!string.IsNullOrEmpty(tempGTIN) &&
                this.GetNumberOfRows(dsItems) == 1)
            {
                if(goBack)
                {
                    //goto Step_ScanLabelStart;
                    goto Step_GoBack;
                }
                itemCode = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                itemDescription = dsItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;

                gtin = tempGTIN;

                if (dsItems.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME))
                {
                    numberOfItemsInPurchaseUnit = Convert.ToDouble(dsItems.Tables[0].Rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                }
                goto Step_GetItemInfo;
            }

            if ((currentLogUnit != null &&
                currentLogUnit.ItemsOnLogisticUnit.Count > 0))
            {
                //we have data in lists
                allowedButtonsIdentifyProductScreen = new string[2] { "MSG_BUTTON_SELECT_PRODUCT", "MSG_BUTTON_RECEIVE_ITEMS" };
            }
            else
            {
                allowedButtonsIdentifyProductScreen = new string[1] { "MSG_BUTTON_SELECT_PRODUCT" };
            }

            goBack = false;

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifyGS1DataScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_IDENTIFY_PRODUCT",
                    "AllowedButtons", allowedButtonsIdentifyProductScreen,
                    "ImageType", GS1ImageType.BoxImage
                    ));
            msg = WaitForMessage();

            //clear data
            initialErrorKey = null;
            //We need to keep old barcode scanned on logistic unit screen
            barcode = null;
            gtin = null;
            itemInfo = null;

            if (msg.Name.EndsWith(".DataEntered"))
            {
                barcode = ExtractParameter<BarcodeContainer>(msg.Parameters, "data");

                //check if there is a product present
                if (barcode != null &&
                !string.IsNullOrEmpty(BarcodeHelper.GetProductIdentification(barcode)))
                {
                    gtin = BarcodeHelper.GetProductIdentification(barcode);

					query = BuildQuery.GetCodeNameItemsOrderByName(null, gtin, purchaseOrderDocEntry, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, true, sboProviderService.GetDbTool());
                    DataSet dsTempItems = sboProviderService.RunView(true, null, null, query);


                    if (GetNumberOfRows(dsTempItems) > 0)
                    {
                        //copy the data
                        itemCode = dsTempItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_CODE.Name] as string;
                        itemDescription = dsTempItems.Tables[0].Rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;

                        if (dsTempItems.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME))
                        {
                            numberOfItemsInPurchaseUnit = Convert.ToDouble(dsTempItems.Tables[0].Rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                        }

                        goto Step_GetItemInfo;
                    }
                    else
                    {
                        initialErrorKey = "MSG_ERROR_PRODUCT_NOT_FOUND";
                        goto Step_IdentifyProduct;
                    }

                }
                else
                {
                    initialErrorKey = "MSG_ERROR_NO_PRODUCT_ON_BARCODE";
                    goto Step_IdentifyProduct;
                }

            }

            if (msg.Name.EndsWith(".ButtonClicked"))
            {
                string tempButtonKey = ExtractParameter<string>(msg.Parameters, "buttonKey");

                if (tempButtonKey == "MSG_BUTTON_SELECT_PRODUCT")
                {
                	//select the product
                	goto Step_SelectProduct;
            	}
                else
                {
                    //receive items
                    // Inform the user items are receiving
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", "MSG_RECEIVING_ALL_ITEMS",
                            "NoTranslationOfMessageKey", false,
                            "ShowButton", false));

                    goto Step_ReceiveItems;
                }
            }

            //go back
            if (currentLogUnit != null &&
                currentLogUnit.ItemsOnLogisticUnit.Count > 0)
            {
                //we want to go back, but we have some items in the list
                //ask user what to do
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                        "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    //goto Step_ScanLabelStart;
                    goto Step_GoBack;
                }

                goto Step_IdentifyProduct;

            }
            else
            {
                //goto Step_ScanLabelStart;
                goto Step_GoBack;
            }

            #endregion

        Step_SelectProduct:

            #region SELECT PRODUCT

            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectProductScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "InitialErrorKey", initialErrorKey,
                    "TitleKey", "MSG_TITLE_SELECT_PRODUCT",
                    "ProductDS", dsItems
                    ));
            msg = WaitForMessage();

            //clear data
            initialErrorKey = null;

            if (msg.Name.EndsWith(".ProductSelected"))
            {
                itemCode = ExtractParameter<string>(msg.Parameters, "itemCode");
                //get itemdescription
                DataRow[] rows = dsItems.Tables[0].Select(string.Format("{0} = '{1}'", ProductDataSet.Columns.PRODUCT_CODE.Name, itemCode));
                if (rows.Length > 0)
                {
                    //copy the data
                    itemDescription = rows[0][ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name] as string;
                }

                if (dsItems.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME))
                {
                    numberOfItemsInPurchaseUnit = Convert.ToDouble(rows[0][SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME]);
                }

                goto Step_GetItemInfo;
            }

            goto Step_IdentifyProduct;

            #endregion

        Step_GetItemInfo:

            #region GET ITEM INFO

            itemInfo = sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), itemCode);

            stillToReceive = GetStillToReceive(dsItemsNonDistinct, itemCode);


            if (!numberOfItemsInPurchaseUnit.HasValue)
            {
                //take default
                numberOfItemsInPurchaseUnit = itemInfo.NumberOfItemsPerPurchaseUnit;
            }

            goto Step_CanItemBeStoredOnLocation;

            #endregion

        Step_CanItemBeStoredOnLocation:

            #region CAN ITEM BE STORED ON LOCATION

            if (!sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCanItemBeStoredOnStorageLocation), itemCode, currentDockCode))
            {
                initialErrorKey = "MSG_ERROR_STORAGE_LOCATION_NOT_ALLOWED_FOR_ITEM";
                goto Step_IdentifyProduct;
            }


            batchNumber = null;
            secondBatchNumber = null;
            bestBeforeDate = null;
            quantity = 0;



            #endregion

        Step_SelectBatchNumber:

            #region SELECT BATCH NUMBER

            batchNumber = null;

            if (itemInfo.HasBatchnumber)
            {

                generatedBatch1Info = sboProviderService.InvokeMethodWithDbConnection<GeneratedBatchNumberReception>(false, false, null, null, new DelegateWithPmxDbConnection<GeneratedBatchNumberReception>(ExecuteGenerateBatchNumber1ForReception), purchaseOrderDocEntry, null, itemCode, cardCode, true);

                tempBatchNumber = null;

                if (barcode != null &&
                    barcode.GS1DataObject != null &&
                    !string.IsNullOrEmpty(barcode.GS1DataObject.LotNumber))
                {
                    tempBatchNumber = barcode.GS1DataObject.LotNumber.ToUpper();
                }

                //If the batchnumber can be overwritten by GS1 batchnumber and it is filled in then
                //we use this batchnumber
                if (generatedBatch1Info.CanBeOverwrittenByGS1BatchNumber && (tempBatchNumber != null) && (tempBatchNumber.Length > 0))
                {
                    if (goBack)
                    {
                        goto Step_IdentifyProduct;
                    }
                    //user cannot change batchnumber
                    batchNumber = tempBatchNumber;
                    goto Step_SecondBatchNumber;
                }
                else
                {
                    tempBatchNumber = generatedBatch1Info.BatchNumber;

                    if (generatedBatch1Info.IsUserAllowedToChange)
                    {
                        //no batchnumber provided, so ask for batchnumber
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IIdentifyBatchNumberScreen),
                         DefaultCultureInfo.Get(), BuildParamCollection(
                             "InitialErrorKey", initialErrorKey,
                             "TitleKey", "MSG_TITLE_IDENTIFY_BATCH_NUMBER",
                             "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                             "ItemDescription", itemDescription,
                             "ItemCode", itemInfo.ItemCode,
                             "ItemBarcode", itemInfo.CodeBars,
                             "StillToReceive", stillToReceive,
                             "CurrentSSCC", SSCC,
                             "InitialBatchNumber", tempBatchNumber,
                             "Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom
                            ));
                        msg = WaitForMessage();

                        // reset error
                        initialErrorKey = null;

                        if (msg.Name.EndsWith(".BatchNumberEntered"))
                        {
                            batchNumber = ExtractParameter<string>(msg.Parameters, "batchNumber");
                            goto Step_SecondBatchNumber;
                        }
                        else if (msg.Name.EndsWith(".BackRequested"))
                        {
                            if (this.GetNumberOfRows(dsItems) == 1)
                            {
                                //go back
                                if (currentLogUnit != null &&
                                    currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                                {
                                    //we want to go back, but we have some items in the list
                                    //ask user what to do
                                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                        DefaultCultureInfo.Get(), BuildParamCollection(
                                            "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                                            "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                                    msg = WaitForMessage();

                                    if (msg.Name.EndsWith(".Yes"))
                                    {
                                        goto Step_ScanLabelStart;
                                    }

                                    goto Step_SelectBatchNumber;
                                }
                                goBack = true;
                                goto Step_IdentifyProduct;
                            }

                            //there where more items in the list
                            goto Step_IdentifyProduct;
                        }

                    }
                    else
                    {
                        if (goBack)
                        {
                            goto Step_IdentifyProduct;
                        }
                        batchNumber = tempBatchNumber;
                    }

                    goBack = false;

                    goto Step_SecondBatchNumber;

                }
            }
            else
            {
                //no batchnumber, so we try to get second batch number
                goto Step_SecondBatchNumber;
            }

            #endregion

        Step_SecondBatchNumber:

            #region ENTER SECOND BATCH NUMBER

            secondBatchNumber = null;

            if (itemInfo.HasSecondBatchNumber)
            {

                generatedBatch2Info = sboProviderService.InvokeMethodWithDbConnection<GeneratedBatchNumberReception>(false, false, null, null, new DelegateWithPmxDbConnection<GeneratedBatchNumberReception>(ExecuteGenerateBatchNumber1ForReception), purchaseOrderDocEntry, null, itemCode, cardCode, false);


                tempBatchNumber = null;

                if (barcode != null &&
                    barcode.GS1DataObject != null &&
                    !string.IsNullOrEmpty(barcode.GS1DataObject.LotNumber))
                {
                    tempBatchNumber = barcode.GS1DataObject.LotNumber.ToUpper();
                }

                //If the batchnumber can be overwritten by GS1 batchnumber and it is filled in then
                //we use this batchnumber
                if (generatedBatch2Info.CanBeOverwrittenByGS1BatchNumber && (tempBatchNumber != null) && (tempBatchNumber.Length > 0))
                {
                    if (goBack)
                    {
                        goto Step_SelectBatchNumber;
                    }
                    //user cannot change batchnumber
                    secondBatchNumber = tempBatchNumber;
                    goto Step_BestBeforeDate;
                }
                else
                {
                    tempBatchNumber = generatedBatch2Info.BatchNumber;

                    if (generatedBatch2Info.IsUserAllowedToChange)
                    {
                        //no batchnumber provided, so ask for batchnumber
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IIdentifyBatchNumberScreen),
                         DefaultCultureInfo.Get(), BuildParamCollection(
                             "InitialErrorKey", initialErrorKey,
                             "TitleKey", "MSG_TITLE_IDENTIFY_BATCH_NUMBER2",
                             "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                             "ItemDescription", itemDescription,
                             "ItemCode", itemInfo.ItemCode,
                             "ItemBarcode", itemInfo.CodeBars,
                             "StillToReceive", stillToReceive,
                             "CurrentSSCC", SSCC,
                             "Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                             "InitialBatchNumber", tempBatchNumber
                            ));
                        msg = WaitForMessage();

                        // reset error
                        initialErrorKey = null;

                        if (msg.Name.EndsWith(".BatchNumberEntered"))
                        {
                            secondBatchNumber = ExtractParameter<string>(msg.Parameters, "batchNumber");
                            goto Step_BestBeforeDate;
                        }
                        else if (msg.Name.EndsWith(".BackRequested"))
                        {
                            goto Step_SelectBatchNumber;
                        }

                    }
                    else
                    {
                        if (goBack)
                        {
                            goto Step_SelectBatchNumber;
                        }
                        secondBatchNumber = tempBatchNumber;
                    }

                    goBack = false;

                    goto Step_BestBeforeDate;

                }
            }
            else
            {
                //no second batchnumber, so we try to get best before date
                goto Step_BestBeforeDate;
            }

            #endregion

        Step_BestBeforeDate:

            #region PROVIDE BEST BEFORE DATE
            if (itemInfo.HasBestBeforeDate)
            {
                if (barcode != null &&
                    barcode.GS1DataObject != null &&
                    barcode.GS1DataObject.BestBeforeDate.HasValue)
                {
                    if (goBack)
                    {
                        if (itemInfo.HasSecondBatchNumber)
                        {
                            goto Step_SecondBatchNumber;
                        }
                        else if (itemInfo.HasBatchnumber)
                        {
                            goto Step_SelectBatchNumber;
                        }


                        if (this.GetNumberOfRows(dsItems) == 1)
                        {
                            //go back
                            if (currentLogUnit != null &&
                                currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                            {
                                //we want to go back, but we have some items in the list
                                //ask user what to do
                                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                    DefaultCultureInfo.Get(), BuildParamCollection(
                                        "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                                        "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                                msg = WaitForMessage();

                                if (msg.Name.EndsWith(".Yes"))
                                {
                                    goto Step_ScanLabelStart;
                                }

                                goto Step_BestBeforeDate;
                            }
                        }
                    }
                    bestBeforeDate = barcode.GS1DataObject.BestBeforeDate.Value;

                    //check if BBD is valid
                    if (SboHelper.ConvertDateToSboDate(bestBeforeDate.Value) < SboHelper.ConvertDateToSboDate(DateTime.Now.AddDays(itemInfo.ShelfLifeInDaysReception)))
                    {
                        // Inform the user the BBD is incorrect
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_ERROR_RECEPTION_BBD_DOES_NOT_MEET_SHELF_LIFE",
                                "MessageAddendum", bestBeforeDate.Value.ToString("dd/MM/yyyy"),
                                "ShowButton", true));
                        WaitForMessage();
                    }

                    //now check if there is an item in stock with later BBD
                    query = BuildQuery.GetStockWithLaterBBD(itemCode, bestBeforeDate.Value);
                    DataSet ds = sboProviderService.RunView(false, null, null, query);

                    if (this.GetNumberOfRows(ds) > 0)
                    {
                        //we found stock with later BBD
                        // Inform the user the BBD is incorrect
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_ERROR_RECEPTION_LATER_BBD_FOUND",
                                "MessageAddendum", ((DateTime)ds.Tables[0].Rows[0][PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME]).ToString("dd/MM/yyyy"),
                                "ShowButton", true));
                        WaitForMessage();
                    }
                }
                else
                {
                    goBack = false;
                    //ask for best before date
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Reception.IEnterBestBeforeDateScreen),
                     DefaultCultureInfo.Get(), BuildParamCollection(
                         "InitialErrorKey", initialErrorKey,
                         "TitleKey", "MSG_TITLE_ENTER_BEST_BEFORE_DATE",
                         "PONumber", purchaseOrderDocNum.HasValue ? purchaseOrderDocNum.Value : (int?)null,
                         "ItemDescription", itemDescription,
                         "ItemCode", itemInfo.ItemCode,
                         "ItemBarcode", itemInfo.CodeBars,
                         "StillToReceive", stillToReceive,
                         "CurrentSSCC", SSCC,
                         "Uom", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                         "BatchNumber", batchNumber
                         ));
                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".BestBeforDateEntered"))
                    {
                        bestBeforeDate = ExtractParameter<DateTime?>(msg.Parameters, "bestBeforeDate");

                        //check if BBD is valid
                        if (SboHelper.ConvertDateToSboDate(bestBeforeDate.Value) < SboHelper.ConvertDateToSboDate(DateTime.Now.AddDays(itemInfo.ShelfLifeInDaysReception)))
                        {
                            //ask user what to do
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "TitleKey", "MSG_TITLE_RECEPTION_BBD_DOES_NOT_MEET_SHELF_LIFE",
                                    "MessageKey", "MSG_QUESTION_RECEPTION_BBD_DOES_NOT_MEET_SHELF_LIFE"));
                            msg = WaitForMessage();

                            if (msg.Name.EndsWith(".Yes"))
                            {
                                goto Step_BestBeforeDate;
                            }
                        }

                        //now check if there is an item in stock with later BBD
                        query = BuildQuery.GetStockWithLaterBBD(itemCode, bestBeforeDate.Value);
                        DataSet ds = sboProviderService.RunView(false, null, null, query);

                        if (this.GetNumberOfRows(ds) > 0)
                        {
                            //we found stock with later BBD
                            //ask user what to do
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "TitleKey", "MSG_TITLE_RECEPTION_LATER_BBD_FOUND",
                                    "MessageKey", "MSG_QUESTION_RECEPTION_LATER_BBD_FOUND",
                                    "Parameters", new object[] { ((DateTime)ds.Tables[0].Rows[0][PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME]).ToString("dd/MM/yyyy") }));
                            msg = WaitForMessage();

                            if (msg.Name.EndsWith(".Yes"))
                            {
                                goto Step_BestBeforeDate;
                            }
                        }


                        goto Step_EnterPackagingQuantity;

                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        if (itemInfo.HasSecondBatchNumber)
                        {
                            goto Step_SecondBatchNumber;
                        }
                        else if (itemInfo.HasBatchnumber)
                        {
                            goto Step_SelectBatchNumber;
                        }


                        if (this.GetNumberOfRows(dsItems) == 1)
                        {
                            //go back
                            if (currentLogUnit != null &&
                                currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                            {
                                //we want to go back, but we have some items in the list
                                //ask user what to do
                                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                                    DefaultCultureInfo.Get(), BuildParamCollection(
                                        "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                                        "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                                msg = WaitForMessage();

                                if (msg.Name.EndsWith(".Yes"))
                                {
                                    goto Step_ScanLabelStart;
                                }

                                goto Step_BestBeforeDate;
                            }
                        }

                        //there where more items in the list
                        goto Step_IdentifyProduct;


                    }
                }

                goto Step_EnterPackagingQuantity;

            }
            else
            {
                //no best before date
                goto Step_EnterPackagingQuantity;
            }

            #endregion

        Step_EnterPackagingQuantity:

            #region ENTER PACKAGING QUANTITY

            if ((itemInfo.HasBatchnumber || itemInfo.HasSecondBatchNumber || itemInfo.HasBestBeforeDate))
            {
                currentListOfTransactionalPackagingTypeInfos = GetTransactionalPackagingInfo(purchaseDeliveryNoteList, batchNumber, secondBatchNumber, bestBeforeDate, itemCode);

                if (currentListOfTransactionalPackagingTypeInfos == null)
                {
                    query = BuildQuery.GetExistingITRI(itemCode, batchNumber, secondBatchNumber, bestBeforeDate);
                    dsExistingBatch = sboProviderService.RunView(false, null, null, query);

                    if (this.GetNumberOfRows(dsExistingBatch) == 0)
                    {
                        //batch not found, so we need to enter the quantity for the packaging types
                        currentListOfTransactionalPackagingTypeInfos = SetItemTransactionalPackagingTypeInfoList(itemInfo);
                        bool foundAtLeastOnePackagingTypeToShowOnScreen = false;
                        bool isFirst = true;
                        listOfPackagingTypeInfosForScreen = new Collection<PackagingTypeInfo>();
                        foreach (PmxItemPackagingTypeInfo packType in itemInfo.ListOfPackagingTypes)
                        {

                            PackagingTypeInfo info = new PackagingTypeInfo();

                            if (isFirst)
                            {
                                info.NumberOfDecimals = itemInfo.UomDecimals;
                            }

                            info.Quantity = packType.Quantity;
                            info.PackagingTypeCode = packType.PackagingTypeCode;
                            info.PackagingTypeName = packType.PackagingTypeName;

							info.ShowOnScreen = (packType.AskDuringReception &&
							(!packType.Barcodes.Contains(gtin)));

                            listOfPackagingTypeInfosForScreen.Add(info);

                            if (!foundAtLeastOnePackagingTypeToShowOnScreen &&
                                info.ShowOnScreen)
                            {
                                foundAtLeastOnePackagingTypeToShowOnScreen = true;
                            }

                            isFirst = false;
                        }

                        if (foundAtLeastOnePackagingTypeToShowOnScreen)
                        {
                            initialErrorKey = "MSG_ENTER_QUANTITY_OF_ALL_PACKAGING_TYPES";
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterPackagingQuantityScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "TitleKey", "MSG_TITLE_ENTER_QUANTITY_OF_ALL_PACKAGING_TYPES",
                                "ItemDescription", itemDescription,
                                "ItemCode", itemInfo.ItemCode,
                                "ItemBarcode", itemInfo.CodeBars,
                                "UOM", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                                "ListOfPackagingTypeInfos", listOfPackagingTypeInfosForScreen,
                                "IsForEnteringDefaultPackagingQuantity", true,
                                "BatchNumber", batchNumber,
                                "BestBeforeDate", bestBeforeDate,
                                "SSCC", SSCC,
                                "DocNum", Convert.ToString(purchaseOrderDocNum)
                                ));

                            msg = WaitForMessage();

                            // reset error
                            initialErrorKey = null;

                            if (msg.Name.EndsWith(".QuantitiesEntered"))
                            {
                                PackagingTypeInfos screenListOfPackagingTypeInfos = ExtractParameter<PackagingTypeInfos>(msg.Parameters, "listOfPackagingTypeInfos");

                                //build the list of packaging quantities
                                foreach (ItemTransactionalPackagingTypeInfo info in currentListOfTransactionalPackagingTypeInfos)
                                {
                                    //try to get new qty from user
                                    if (screenListOfPackagingTypeInfos.PackagingTypeInfoList.ContainsKey(info.PackagingTypeCode))
                                    {
                                        info.Quantity = screenListOfPackagingTypeInfos.PackagingTypeInfoList[info.PackagingTypeCode].Quantity;
                                    }
                                }

                                goto Step_EnterQuantity;
                            }
                            else if (msg.Name.EndsWith(".BackRequested"))
                            {
                                if (itemInfo.HasBestBeforeDate)
                                {
                                    goto Step_BestBeforeDate;
                                }
                                else if (itemInfo.HasSecondBatchNumber)
                                {
                                    goto Step_SecondBatchNumber;
                                }

                                goto Step_SelectBatchNumber;
                            }

                        }

                    }
                    else
                    {
                        //we found the batch, so now fill in the packaging data from the batch
                        currentListOfTransactionalPackagingTypeInfos = new Collection<ItemTransactionalPackagingTypeInfo>();
                        foreach (DataRow row in dsExistingBatch.Tables[0].Rows)
                        {
                            ItemTransactionalPackagingTypeInfo newPackInfo = new ItemTransactionalPackagingTypeInfo();

                            newPackInfo.PackagingTypeCode = Convert.ToString(row[PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME]);
                            newPackInfo.Quantity = Convert.ToDouble(row[PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME]);
                            newPackInfo.ItriKey = Convert.ToInt32(row[PmxItemTransactionalInfoTable.Columns.InternalKey.NAME]);

                            newPackInfo.ItemCode = itemInfo.ItemCode;

                            currentListOfTransactionalPackagingTypeInfos.Add(newPackInfo);
                        }

                        goto Step_EnterQuantity;
                    }
                }

                goto Step_EnterQuantity;
            }
            else
            {
                //no batch info
                //get the packaging types qty from item
                currentListOfTransactionalPackagingTypeInfos = SetItemTransactionalPackagingTypeInfoList(itemInfo);



                goto Step_EnterQuantity;
            }

            #endregion

        Step_EnterQuantity:

            #region ENTER QUANTITY

            quantity = 0;
            listOfSerialNumbers = null;

            if (IsQuantityOnBarcode(barcode))
            {
                initialQuantity = Convert.ToDouble(barcode.GS1DataObject.Count);
            }
            else
            {
                initialQuantity = 1;
            }

            if (this.IsLUOnBarcode(barcode))
            {
                maxQuantity = 1;
            }
            else
            {
                maxQuantity = -1;
            }

            bool getNormalQuantity = true;

            if (itemInfo.HasSerialNumber &&
                batchReceivingNumber == 1)
            {
                #region SERIAL NUMBER

                getNormalQuantity = false;

                //show screen to ask user what to do.
                buttonKeys = new string[3] { "MSG_BUTTON_SERIAL_NUMBER", "MSG_BUTTON_SERIAL_NUMBER_RANGE", "MSG_BUTTON_NO_SERIAL_NUMBER" };

                toolBarButtons = ToolBarButtons.Back;

                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectButtonScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", "MSG_TITLE_ENTER_QUANTITY_SERIAL_NUMBER_TASK",
                        "AllowedButtons", buttonKeys,
                        "EnabledToolBarButtons", toolBarButtons
                        ));
                msg = WaitForMessage();
                initialErrorKey = null;
                if (msg.Name.EndsWith(".ButtonClicked"))
                {
                    filterButtonKey = ExtractParameter<string>(msg.Parameters, "buttonKey");

                    if (filterButtonKey == "MSG_BUTTON_SERIAL_NUMBER" ||
                        filterButtonKey == "MSG_BUTTON_SERIAL_NUMBER_RANGE")
                    {
                        #region ENTER SERIAL NUMBERS


                        //get ITRI
                        int? itriKey = null;
                        if (itemInfo.HasBestBeforeDate ||
                            itemInfo.HasSecondBatchNumber ||
                            itemInfo.HasBatchnumber)
                        {
                            itriKey = sboProviderService.InvokeMethodWithDbConnection<int?>(false, false, null, null, new DelegateWithPmxDbConnection<int?>(ExecuteGetCreateItemTransactionalInfoKey), itemCode, batchNumber, secondBatchNumber, bestBeforeDate);
                        }


                        bool isSerialNumberRange = (filterButtonKey == "MSG_BUTTON_SERIAL_NUMBER_RANGE");

                        m_enterQuantitySubFlow.BindParameters(
                            this.DefaultCultureInfo,
                            this.PmxOseCompany,
                            new ReadOnlyBinder<string>("TitleKey", "MSG_TITLE_ENTER_QUANTITY"),
                            new ReadOnlyBinder<PmxItemInfo>("ItemInfo", itemInfo),
                            new ReadOnlyBinder<string>("BatchNumber", batchNumber),
                            new ReadOnlyBinder<DateTime?>("BestBeforeDate", bestBeforeDate),
                            new ReadOnlyBinder<int?>("ItriKey", itriKey),
                            new ReadOnlyBinder<string>("LocationCode", currentDockCode),
                            new ReadOnlyBinder<string>("SSCC", SSCC),

                            new ReadOnlyBinder<string>("DocNum", Convert.ToString(purchaseOrderDocNum)),
                            new ReadOnlyBinder<bool>("UsePickingInfo", false),

                            new ReadOnlyBinder<bool>("AllowZero", false),
                            new ReadOnlyBinder<double>("InitialQuantity", initialQuantity),
                            new ReadOnlyBinder<string>("MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE"),
                            new ReadOnlyBinder<double>("StillToQuantity", stillToReceive),
                            new ReadOnlyBinder<double>("MaximumQuantity", maxQuantity),
                            new ReadOnlyBinder<double>("TotalQuantityToPick", 0),
                            new ReadOnlyBinder<string>("UOM", itemInfo.PurchaseUom),
                            new ReadOnlyBinder<int>("NumberOfDigitsAfterDecimal", (itemInfo != null) ? itemInfo.UomDecimals : 0),

                            new ReadOnlyBinder<double>("InnerQuantity", numberOfItemsInPurchaseUnit.Value),
                            new ReadOnlyBinder<string>("InnerUOM", itemInfo.InventoryUom),
                            new ReadOnlyBinder<bool>("ForceInputSerialNumbers", true),
                            new ReadOnlyBinder<string>("ObjectType", ((int)SboLinkDocumentType.PurchaseOrder).ToString()),
                            new ReadOnlyBinder<int?>("DocEntry", purchaseOrderDocNum),
                            new ReadOnlyBinder<bool>("UseSerialNumberRange", isSerialNumberRange),
                            new ReadOnlyBinder<string>("LocationCode", currentDockCode),

                            new ReadWriteBinder<double>("QuantityEntered", this, "m_subFlowQuantity"),
                            new ReadWriteBinder<bool>("BackRequested", this, "m_subFlowBackRequested"),
                            new ReadWriteBinder<Collection<string>>("ListOfSerialNumbers", this, "m_subFlowListOfSerialNumbers")

                            );
                        m_subFlowBackRequested = false;
                        this.StartSubFlowAndWait(m_enterQuantitySubFlow, true);

                        if (m_subFlowBackRequested)
                        {
                            goto Step_EnterQuantity;
                        }

                        listOfSerialNumbers = m_subFlowListOfSerialNumbers;

                        quantity = m_subFlowQuantity;

                        goto Step_CheckQuantity;

                        #endregion
                        
                    }

                    getNormalQuantity = true;
                }

                if (msg.Name.EndsWith(".BackRequested"))
                {
                    goBack = true;
                    goto Step_GoBackOnEnterQuantity;
                }



                #endregion
            }

            if(getNormalQuantity)
            {
                if (itemInfo.ListOfPackagingTypes != null &&
                    currentListOfTransactionalPackagingTypeInfos.Count > 0)
                {
                    #region QUANTITY WITH PACKAGING TYPE

                    //build list of packaging types

                    listOfPackagingTypeInfosForScreen = new Collection<PackagingTypeInfo>();

                    //add first one for the uom

                    PackagingTypeInfo info = new PackagingTypeInfo();

                    info.Quantity = 1;
                    info.PackagingTypeCode = null;
                    info.PackagingTypeName = itemInfo.InventoryUom == null ? itemInfo.ItemCode : itemInfo.InventoryUom;
                    info.QuantityPerPack = 1;
					if (!string.IsNullOrEmpty(itemInfo.CodeBars))
					{
						info.Barcode.Add(itemInfo.CodeBars);
					} 
					info.NumberOfDecimals = itemInfo.UomDecimals;
					if (info.Barcode.Contains(gtin))
					{
						info.InitialQuantity = 1;
					}
					else
					{
						info.InitialQuantity = 0;
					}
                    listOfPackagingTypeInfosForScreen.Add(info);


                    foreach (ItemTransactionalPackagingTypeInfo packType in currentListOfTransactionalPackagingTypeInfos)
                    {

                        info = new PackagingTypeInfo();

                        info.Quantity = packType.Quantity;
                        info.PackagingTypeCode = packType.PackagingTypeCode;
                        info.PackagingTypeName = GetPackTypeName(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);
                        info.Barcode = GetPackBarcode(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);
                        info.HideDuringEnteringQuantity = GetHideDuringEnteringQuantity(packType.PackagingTypeCode, itemInfo.ListOfPackagingTypes);

						if (info.Barcode.Contains(gtin))
						{
							info.InitialQuantity = 1;
							//Check if barcode is also added to inventory uom.
							//If so, we need to adjust initial qty
							if (listOfPackagingTypeInfosForScreen[0].Barcode.Contains(gtin))
							{
								listOfPackagingTypeInfosForScreen[0].InitialQuantity = 0;
							}
						}
						else
						{
							info.InitialQuantity = 0;
						}

                        info.QuantityPerPack = packType.Quantity;

                        listOfPackagingTypeInfosForScreen.Add(info);
                    }




                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterPackagingQuantityScreen),
                                        DefaultCultureInfo.Get(), BuildParamCollection(
                                        "InitialErrorKey", initialErrorKey,
                                        "TitleKey", "MSG_TITLE_ENTER_QUANTITY",
                                        "ItemDescription", itemDescription,
                                        "ItemCode", itemInfo.ItemCode,
                                        "ItemBarcode", itemInfo.CodeBars,
                                        "UOM", string.IsNullOrEmpty(itemInfo.PurchaseUom) ? itemInfo.InventoryUom : itemInfo.PurchaseUom,
                                        "ListOfPackagingTypeInfos", listOfPackagingTypeInfosForScreen,
                                        "IsForEnteringDefaultPackagingQuantity", false,
                                        "BatchNumber", batchNumber,
                                        "BestBeforeDate", bestBeforeDate,
                                        "SSCC", SSCC,
                                        "DocNum", Convert.ToString(purchaseOrderDocNum),
                                        "StillToQuantity", stillToReceive,
                                        "MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE",
                                        "AllowZero", false
                                        ));

                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantitiesEntered"))
                    {
                        PackagingTypeInfos screenListOfPackagingTypeInfos = ExtractParameter<PackagingTypeInfos>(msg.Parameters, "listOfPackagingTypeInfos");

                        //build the list of packaging quantities
                        foreach (PackagingTypeInfo infoForQty in screenListOfPackagingTypeInfos.PackagingTypeInfoList.Values)
                        {
                            quantity += (infoForQty.Quantity * infoForQty.QuantityPerPack);
                        }

                        goto Step_CheckQuantity;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;
                        //if (itemInfo.HasBestBeforeDate)
                        //{
                        //    goto Step_BestBeforeDate;
                        //}
                        //else if (itemInfo.HasSecondBatchNumber)
                        //{
                        //    goto Step_SecondBatchNumber;
                        //}
                        //else if (itemInfo.HasBatchnumber)
                        //{
                        //    goto Step_SelectBatchNumber;
                        //}

                        //if (this.GetNumberOfRows(dsItems) == 1)
                        //{
                        //    //go back
                        //    if (currentLogUnit != null &&
                        //        currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                        //    {
                        //        //we want to go back, but we have some items in the list
                        //        //ask user what to do
                        //        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        //            DefaultCultureInfo.Get(), BuildParamCollection(
                        //                "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                        //                "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                        //        msg = WaitForMessage();

                        //        if (msg.Name.EndsWith(".Yes"))
                        //        {
                        //            goto Step_ScanLabelStart;
                        //        }

                        //        goto Step_EnterQuantity;
                        //    }
                        //}

                        //goto Step_IdentifyProduct;
                    }
                    #endregion
                }
                else
                {
                    #region QUANTITY NO PACKAGING TYPE

                    //no packaging types, so enter quantity on 'normal' way
                   


                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IEnterQuantityWithItemInfoScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "TitleKey", "MSG_TITLE_ENTER_QUANTITY",
                        "ItemDescription", itemDescription,
                        "ItemCode", itemInfo.ItemCode,
                        "ItemBarcode", itemInfo.CodeBars,
                        "InitialQuantity", initialQuantity,
                        "InnerQuantity", numberOfItemsInPurchaseUnit.Value,
                        "MaximumQuantity", maxQuantity,
                        "NumberOfDigitsAfterDecimal", itemInfo.UomDecimals,
                        "InnerUOM", itemInfo.InventoryUom,
                        "UOM", itemInfo.PurchaseUom,
                        "BatchNumber", batchNumber,
                        "BestBeforeDate", bestBeforeDate,
                        "SSCC", SSCC,
                        "DocNum", Convert.ToString(purchaseOrderDocNum),
                        "StillToQuantity", stillToReceive,
                        "MessageKeyStillQuantity", "MSG_LBL_STILL_TO_RECEIVE"
                        ));

                    msg = WaitForMessage();

                    // reset error
                    initialErrorKey = null;

                    if (msg.Name.EndsWith(".QuantityEntered"))
                    {
                        quantity = ExtractParameter<double>(msg.Parameters, "quantity");

                        goto Step_CheckQuantity;
                    }
                    else if (msg.Name.EndsWith(".BackRequested"))
                    {
                        goBack = true;

                        //if (itemInfo.HasBestBeforeDate)
                        //{
                        //    goto Step_BestBeforeDate;
                        //}
                        //else if (itemInfo.HasSecondBatchNumber)
                        //{
                        //    goto Step_SecondBatchNumber;
                        //}
                        //else if (itemInfo.HasBatchnumber)
                        //{
                        //    goto Step_SelectBatchNumber;
                        //}


                        //if (this.GetNumberOfRows(dsItems) == 1)
                        //{
                        //    //go back
                        //    if (currentLogUnit != null &&
                        //        currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                        //    {
                        //        //we want to go back, but we have some items in the list
                        //        //ask user what to do
                        //        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        //            DefaultCultureInfo.Get(), BuildParamCollection(
                        //                "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                        //                "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                        //        msg = WaitForMessage();

                        //        if (msg.Name.EndsWith(".Yes"))
                        //        {
                        //            goto Step_ScanLabelStart;
                        //        }

                        //        goto Step_EnterQuantity;
                        //    }
                        //}

                        ////there where more items in the list
                        //goto Step_IdentifyProduct;

                    }

                    #endregion
                }
            }

         Step_GoBackOnEnterQuantity:

            //go back

            goBack = true;

            if (itemInfo.HasBestBeforeDate)
            {
                goto Step_BestBeforeDate;
            }
            else if (itemInfo.HasSecondBatchNumber)
            {
                goto Step_SecondBatchNumber;
            }
            else if (itemInfo.HasBatchnumber)
            {
                goto Step_SelectBatchNumber;
            }


            if (this.GetNumberOfRows(dsItems) == 1)
            {
                //go back
                if (currentLogUnit != null &&
                    currentLogUnit.ItemsOnLogisticUnit.Count > 0)
                {
                    //we want to go back, but we have some items in the list
                    //ask user what to do
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "TitleKey", "MSG_TITLE_PRODUCTS_ON_PALLET_TO_RECEIVE",
                            "MessageKey", "MSG_QUESTION_PRODUCTS_ON_PALLET_TO_RECEIVE"));
                    msg = WaitForMessage();

                    if (msg.Name.EndsWith(".Yes"))
                    {
                        goto Step_ScanLabelStart;
                    }

                    goto Step_EnterQuantity;
                }
            }

            //there where more items in the list
            goto Step_IdentifyProduct;



            #endregion

        Step_CheckQuantity:

            #region CHECK QUANTITY


            double qtyToCheck = 0;
            if (itemInfo.ListOfPackagingTypes != null &&
                listOfPackagingTypeInfosForScreen != null &&
            listOfPackagingTypeInfosForScreen.Count > 0)
            {
                //if packaging types are entered, the quantity is in inventory uom,
                //so we need to adjust the quantity to receive
                qtyToCheck = (quantity / numberOfItemsInPurchaseUnit.Value);
            }
            else
            {
                qtyToCheck = quantity;
            }

            double fullQuantity = qtyToCheck * batchReceivingNumber;


            if (fullQuantity > stillToReceive &&
                stillToReceive > 0)
            {
                //ask user what to do
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_RECEIVING_MORE_THAN_ORDERED",
                        "MessageKey", "MSG_QUESTION_RECEIVING_MORE_THAN_ORDERED"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    //re-enter the quantity
                    goto Step_EnterQuantity;
                }
            }

            goto Step_PrintItemLabel;

            #endregion

        Step_PrintItemLabel:

            #region PRINT ITEM LABEL
            numberOfItemLabels = 0;
            if (itemInfo.PrintItemLabel)
            {
                if (currentPmxOseCompany.GoodsReceiptAutoPrintItemLabels)
                {
                    numberOfItemLabels = Convert.ToInt32(Math.Ceiling(quantity));
                }
                else
                {
                    //ask user if he wants to print item labels
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "TitleKey", "MSG_TITLE_PRINT_ITEM_LABEL",
                            "MessageKey", "MSG_QUESTION_PRINT_ITEM_LABEL"));
                    msg = WaitForMessage();

                    if (msg.Name.EndsWith(".Yes"))
                    {
                        numberOfItemLabels = Convert.ToInt32(Math.Ceiling(quantity));
                    }

                }

                if (numberOfItemLabels > 0)
                {
                    // print the labels

                    //Set the data into binders
                    this.m_printItemLabelFlow_LocationCode = currentDockCode;
                    this.m_printItemLabelFlow_NeededBatchNumber = batchNumber;
                    this.m_printItemLabelFlow_NeededBestBeforeDate = bestBeforeDate;
                    this.m_printItemLabelFlow_NeededItemCode = itemInfo.ItemCode;
                    this.m_printItemLabelFlow_NeededNrOfLabels = numberOfItemLabels;

                    //call flow
                    base.StartSubFlowAndWait(m_printItemLabelFlow, false);
                   

                    if (m_printItemLabelFlow_BackRequested)
                    {
                        goto Step_EnterQuantity;
                    }
                }

                goto Step_EnterCurrentDataIntoList;


            }
            else
            {
                goto Step_EnterCurrentDataIntoList;
            }

            #endregion

        Step_EnterCurrentDataIntoList:

            #region ENTER CURRENT DATA INTO LIST


            //Use the first logistic unit. This because the code at this moment only supports
            //reception of one logistic unit that must be saved as a good receipt.
            LogisticUnitItemGoodReceipt logUnitItem = new LogisticUnitItemGoodReceipt();
            logUnitItem.BatchNumber1 = batchNumber;
            logUnitItem.BatchNumber2 = secondBatchNumber;
            logUnitItem.BestBeforeDate = bestBeforeDate;
            logUnitItem.ItemCode = itemInfo.ItemCode;
            logUnitItem.PurchaseDocRef = purchaseOrderDocEntry.HasValue ? new Produmex.Foundation.Data.Sbo.DataObjects.DocumentRef(SboObjectType.PurchaseOrder, purchaseOrderDocEntry.Value) : null;
            logUnitItem.IsLogisticCarrierForLogisticUnit = false;
            logUnitItem.IsLogisticCarrier = itemInfo.IsLogisticCarrier;
            logUnitItem.QuantityPerUom = numberOfItemsInPurchaseUnit.Value;

            logUnitItem.ListOfSerialNumbers = listOfSerialNumbers;



            if (listOfPackagingTypeInfosForScreen != null &&
                listOfPackagingTypeInfosForScreen.Count > 0)
            {
                //Screen list in in wrong order, so reversing order
                Collection<PackagingTypeInfo> tempList = new Collection<PackagingTypeInfo>();
                for (int iLoop = listOfPackagingTypeInfosForScreen.Count - 1; iLoop >= 0; iLoop--)
                {
                    tempList.Add(listOfPackagingTypeInfosForScreen[iLoop]);
                }

                logUnitItem.FullListOfPackagingTypes = tempList;
            }


            if (itemInfo.ListOfPackagingTypes != null &&
                listOfPackagingTypeInfosForScreen != null &&
            listOfPackagingTypeInfosForScreen.Count > 0)
            {
                //if packaging types are entered, the quantity is in inventory uom,
                //so we need to adjust the quantity to receive
                logUnitItem.Quantity = (quantity / numberOfItemsInPurchaseUnit.Value);
            }
            else
            {
                logUnitItem.Quantity = quantity;
            }


            logUnitItem.ListOfPackagingTypes = currentListOfTransactionalPackagingTypeInfos;

            logUnitItem.AutoSelectPO = autoSelectPO;

            if (currentLogisticCarrier != null)
            {
                //add logistic carrier to list when it is set
                LogisticUnitItemGoodReceipt logUnitItemLogCar = new LogisticUnitItemGoodReceipt();

                logUnitItemLogCar.IsLogisticCarrierForLogisticUnit = currentLogisticCarrier.IsLogisticCarrierForLogisticUnit;
                logUnitItemLogCar.IsLogisticCarrier = currentLogisticCarrier.IsLogisticCarrier;
                logUnitItemLogCar.BatchNumber1 = currentLogisticCarrier.BatchNumber1;
                logUnitItemLogCar.BatchNumber2 = currentLogisticCarrier.BatchNumber2;
                logUnitItemLogCar.BestBeforeDate = currentLogisticCarrier.BestBeforeDate;
                logUnitItemLogCar.ItemCode = currentLogisticCarrier.ItemCode;
                logUnitItemLogCar.Quantity = currentLogisticCarrier.Quantity;
                


                currentLogUnit.ItemsOnLogisticUnit.Add(logUnitItemLogCar);

                currentLogisticCarrier = null;
            }

            currentLogUnit.ItemsOnLogisticUnit.Add(logUnitItem);


            goto Step_AskToAddMore;


            #endregion

        Step_AskToAddMore:

            #region ASK TO ADD MORE

            if (this.IsLUOnBarcode(barcode))
            {
                //no more items allowed
                goto Step_EnterDataIntoListToReceive;
            }

            if (purchaseOrderDocEntry.HasValue)
            {
                //check if there are still items to receive
				query = BuildQuery.GetCodeNameItemsOrderByName(null, null, purchaseOrderDocEntry, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, sboProviderService.GetDbTool());
                dsCheckItems = sboProviderService.RunView(true, null, null, query);

                RemoveReceivedItems(purchaseDeliveryNoteList, dsCheckItems, currentLogUnit);

                if (this.GetNumberOfRows(dsCheckItems) == 0)
                {
                    //no more rows, so add the data
                    goto Step_EnterDataIntoListToReceive;
                }
            }


            //ask user if he wants to add another item to the list
            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                DefaultCultureInfo.Get(), BuildParamCollection(
                    "TitleKey", "MSG_TITLE_ADD_MORE_PRODUCTS",
                    "MessageKey", "MSG_QUESTION_ADD_MORE_PRODUCTS"));
            msg = WaitForMessage();

            if (msg.Name.EndsWith(".Yes"))
            {
                goto Step_ClearDataBeforeNextItem;
            }

            goto Step_EnterDataIntoListToReceive;



            #endregion

        Step_EnterDataIntoListToReceive:

            #region ENTER DATA INTO LIST TO RECEIVE

            currentLogUnit.SpecificLocationCode = null;



            Collection<Dictionary<string, object>> listOfListOfParameters = new Collection<Dictionary<string, object>>();


            for (int iLoop = 0; iLoop < batchReceivingNumber; iLoop++)
            {
                //check if there is locked stock
                if (purchaseOrderDocEntry.HasValue &&
                    string.IsNullOrEmpty(currentLogUnit.SSCC))
                {
                    Collection<string> listOfItemCodes = new Collection<string>();
                    foreach (LogisticUnitItemGoodReceipt item in currentLogUnit.ItemsOnLogisticUnit)
                    {
                        if (!listOfItemCodes.Contains(item.ItemCode))
                        {
                            listOfItemCodes.Add(item.ItemCode);
                        }
                    }
                    query = BuildQuery.GetLockedStockForBaseOrder(listOfItemCodes, purchaseOrderDocEntry.Value);
                    dsSSCC = sboProviderService.RunView(true, null, null, query);

                    if (this.GetNumberOfRows(dsSSCC) > 0)
                    {
                        //we found stock, so we ask user what to do
                        //ask user if he wants to add another item to the list
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IIdentifySSCCListScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "TitleKey", "MSG_TITLE_FOUND_STOCK_FOR_SAME_ORDER",
                                "SSCCDS", dsSSCC,
                                "ButtonKey", "MSG_BUTTON_MAKE_NEW_SSCC"
                                ));
                        msg = WaitForMessage();

                        if (msg.Name.EndsWith(".SSCCEntered"))
                        {
                            int scannedLUID = ExtractParameter<int>(msg.Parameters, "luid");

                            DataRow[] rows = dsSSCC.Tables[0].Select(SSCCDataSet.Columns.LUID.Name + " = " + scannedLUID);
                            if (rows.Length > 0)
                            {
                                currentLogUnit.SpecificLocationCode = Convert.ToString((rows[0][SSCCDataSet.Columns.STORAGE_LOCATION_CODE.Name]));
                                currentLogUnit.SSCC = ExtractParameter<string>(msg.Parameters, "sscc");
                                currentLogUnit.LogisticUnitId = scannedLUID;
                            }

                            //if logistic carrier was defined, we need to set IsLOgisticCarrier to false,
                            //otherwise the system will try to add it as the logistic carrier for the logistic unit.
                            //But it is possible the logistic unit to move the items to already has a logistic carrier linked to it.
                            foreach (LogisticUnitItemGoodReceipt tempItem in currentLogUnit.ItemsOnLogisticUnit)
                            {
                                if (tempItem.IsLogisticCarrierForLogisticUnit)
                                {
                                    tempItem.IsLogisticCarrierForLogisticUnit = false;
                                    //there should be only one logistic carrier
                                    break;
                                }
                            }

                        }

                    }

                }

                LogisticUnitGoodsReceipt logUnitToAdd = new LogisticUnitGoodsReceipt();

                logUnitToAdd.SSCC = currentLogUnit.SSCC;
                logUnitToAdd.LogisticUnitId = currentLogUnit.LogisticUnitId;
                logUnitToAdd.SupplierPalletNumber = currentLogUnit.SupplierPalletNumber;
                logUnitToAdd.SpecificLocationCode = currentLogUnit.SpecificLocationCode;

                logUnitToAdd.ItemsOnLogisticUnit = currentLogUnit.ItemsOnLogisticUnit;
                


                if (!logUnitToAdd.LogisticUnitId.HasValue)
                {
                    //add luid
                    try
                    {
                        logUnitToAdd.LogisticUnitId = sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null, new DelegateWithPmxDbConnection<int>(ExecuteGenerateLuid), logUnitToAdd.SSCC, logUnitToAdd.SupplierPalletNumber);

                        //get the sscc
                        if (string.IsNullOrEmpty(logUnitToAdd.SSCC) &&
                            logUnitToAdd.LogisticUnitId.HasValue)
                        {
                            logUnitToAdd.SSCC = sboProviderService.InvokeMethodWithDbConnection<string>(false, false, null, null, new DelegateWithPmxDbConnection<string>(ExecuteGetSSCCByLUID), logUnitToAdd.LogisticUnitId.Value);
                        }

                    }
                    catch (Exception ex)
                    {
                        if (!(ex is ProdumexException))
                        {
                            // Inform the user with the error
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "MessageKey", ex.Message,
                                    "NoTranslationOfMessageKey", true,
                                    "ShowButton", true));
                            WaitForMessage();

                        }
                        else
                        {
                            // Inform the user with the error
                            session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                                DefaultCultureInfo.Get(), BuildParamCollection(
                                    "PmxError", ((ProdumexException)ex).Error,
                                    "ShowButton", true));
                            WaitForMessage();
                        }

                    }
                }

                //only print if not moving to locked stock location

                if (string.IsNullOrEmpty(logUnitToAdd.SpecificLocationCode))
                {

                    try
                    {
                        Dictionary<string, object> listOfParameters = new Dictionary<string, object>();



                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.CardCode.NAME, cardCode);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PurchaseDocEntry.NAME, purchaseOrderDocEntry);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.SSCC.NAME, logUnitToAdd.SSCC);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.InternalLUID.NAME, logUnitToAdd.LogisticUnitId);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.LocationCode.NAME, currentDockCode);


                        string tempItemCode = null;
                        string tempBatch = null;
                        string tempBatch2 = null;
                        DateTime? tempBestBeforeDate = null;
                        double? tempQuantity = 0;
                        Collection<PackagingTypeInfo> tempListOfPackagingTypes = null;
                        bool isFirst = true;

                        foreach (LogisticUnitItemGoodReceipt temp in logUnitToAdd.ItemsOnLogisticUnit)
                        {
                            if ((isFirst && !temp.IsLogisticCarrierForLogisticUnit) ||
                                (isFirst && temp.IsLogisticCarrierForLogisticUnit && temp.Quantity > 1))
                            {
                                //we need to fill the current data
                                tempItemCode = temp.ItemCode;
                                tempBatch = temp.BatchNumber1;
                                tempBatch2 = temp.BatchNumber2;
                                tempBestBeforeDate = temp.BestBeforeDate;
                                tempQuantity = temp.Quantity;
                                tempListOfPackagingTypes = temp.FullListOfPackagingTypes;

                                isFirst = false;

                            }
                            else
                            {
                                if (!isFirst)
                                {
                                    if ((tempItemCode != temp.ItemCode &&
                                        !temp.IsLogisticCarrierForLogisticUnit) ||
                                        (tempItemCode != temp.ItemCode &&
                                        temp.IsLogisticCarrierForLogisticUnit && temp.Quantity > 1))
                                    {
                                        tempItemCode = null;
                                        tempBatch = null;
                                        tempBatch2 = null;
                                        tempBestBeforeDate = null;
                                        tempQuantity = null;
                                        tempListOfPackagingTypes = null;
                                        break;
                                    }
                                    else
                                    {
                                        if (!temp.IsLogisticCarrierForLogisticUnit)
                                        {
                                            //check if bestbefore date and batchnum correspond
                                            if (tempBatch != temp.BatchNumber1 ||
                                                tempBatch2 != temp.BatchNumber2)
                                            {
                                                tempBatch = null;
                                                tempBatch2 = null;
                                            }

                                            if (tempBestBeforeDate != temp.BestBeforeDate)
                                            {
                                                tempBestBeforeDate = null;
                                            }

                                            tempQuantity += temp.Quantity;
                                        }
                                    }
                                }
                            }
                        }


                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.Quantity.NAME, tempQuantity);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BatchNumber.NAME, tempBatch);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BestBeforeDate.NAME, tempBestBeforeDate);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.ItemCode.NAME, tempItemCode);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.BatchNumber2.NAME, tempBatch2);

                        string tempPackagingTypeText = null;
                        string tempQuantityByPackText = null;
                        if (tempListOfPackagingTypes != null &&
                            tempQuantity.HasValue)
                        {
                            tempPackagingTypeText = this.GetTransactionalPackagingTypesText(tempQuantity.Value, null, tempListOfPackagingTypes);
                            tempQuantityByPackText = this.GetQuantityInPackagingTypesText(tempListOfPackagingTypes);
                        }

                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.PackagingTypeText.NAME, tempPackagingTypeText);
                        listOfParameters.Add(Produmex.Sbo.Logex.Data.Reports.Definitions.ReportTypeLogisticUnitDefinition.Parameters.QuantityByPackagingTypeText.NAME, tempQuantityByPackText);


                        listOfListOfParameters.Add(listOfParameters);

                    }
                    catch (Produmex.Foundation.ProdumexException ex)
                    {
                        s_log.Error(ex.ToString());
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                "MessageAddendum", ex.Message,
                                "PmxError", ex.Error,
                                "ShowButton", true));

                        msg = WaitForMessage();
                    }
                    catch (Exception ex)
                    {
                        s_log.Error(ex.ToString());
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                "MessageAddendum", ex.Message,
                                "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                                "ShowButton", true));

                        msg = WaitForMessage();
                    }

                }

                purchaseDeliveryNoteList.Add(logUnitToAdd);

            }
                                                         
            //only print if not moving to locked stock location
            //When no parameters are filled in, stock will be moved to locked stock location
            if (listOfListOfParameters.Count > 0)
            {
                //print the label
                bool proceed = false;
                while (!proceed)
                {
                    numberOfReports = 0;

                    try
                    {
                        //trigger event
                        numberOfReports += sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null, new DelegateWithPmxDbConnection<int>(ExecutePrintReportsForEventWithParametersCollection), PmxPrintReportEventType.ReceptionNewLogisticUnitIdentified, currentDockCode, deviceID, listOfListOfParameters, false);
                    }
                    catch (Produmex.Foundation.ProdumexException ex)
                    {
                        s_log.Error(ex.ToString());
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                "MessageAddendum", ex.Message,
                                "PmxError", ex.Error,
                                "ShowButton", true));

                        msg = WaitForMessage();
                    }
                    catch (Exception ex)
                    {
                        s_log.Error(ex.ToString());
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "InitialErrorKey", initialErrorKey,
                                "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                                "MessageAddendum", ex.Message,
                                "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                                "ShowButton", true));

                        msg = WaitForMessage();
                    }

                    if (numberOfReports > 0)
                    {
                        session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                            DefaultCultureInfo.Get(), BuildParamCollection(
                                "MessageKey", "MSG_QUESTION_REPRINT_LABEL",
                                "TitleKey", "MSG_TITLE_REPRINT_LABEL"));

                        msg = WaitForMessage();

                        if (msg.Name.EndsWith(".No"))
                        {
                            proceed = true;
                        }

                    }
                    else
                    {
                        proceed = true;
                    }

                }
            }



            currentLogUnit = null;

            if (gotoReceiveItem)
            {
                goto Step_ReceiveItems;
            }

            if (receiveAllItemsOnOnePurchaseDelivery)
            {
                if (purchaseOrderDocEntry.HasValue)
                {
                    //check if there are still items to receive
					query = BuildQuery.GetCodeNameItemsOrderByName(null, null, purchaseOrderDocEntry, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, sboProviderService.GetDbTool());
                    dsCheckItems = sboProviderService.RunView(true, null, null, query);

                    RemoveReceivedItems(purchaseDeliveryNoteList, dsCheckItems, currentLogUnit);

                    if (this.GetNumberOfRows(dsCheckItems) == 0)
                    {
                        //no more rows, so receive the data
                        goto Step_ReceiveItems;
                    }
                }

                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_NO_PO")
                {
                    goto Step_ReceiveItems;
                }

                goto Step_ShowMessageNextLogisticUnit;
            }
            else
            {
                goto Step_ReceiveItems;
            }


            #endregion

        Step_ReceiveItems:

            #region RECEIVE ITEMS

            listOfGeneratedDocEntry = new KeyValuePair<Collection<DocumentRef>, Collection<int>>();
            gotoReceiveItem = false;
            //add current pallet, if it was not added yet
            if (currentLogUnit != null &&
                currentLogUnit.ItemsOnLogisticUnit.Count > 0 &&
                !goBack)
            {
                gotoReceiveItem = true;
                goto Step_EnterDataIntoListToReceive;
            }

            try
            {
                listOfGeneratedDocEntry = sboProviderService.InvokeMethodWithDbConnection<KeyValuePair<Collection<DocumentRef>, Collection<int>>>(true, false, null, null, new DelegateWithPmxDbConnection<KeyValuePair<Collection<DocumentRef>, Collection<int>>>(ExecuteAddPurchaseDeliveryNoteListOfLogisticUnits), cardCode, currentDockCode, purchaseDeliveryNoteList, supplierRef);

                purchaseDeliveryNoteList = new Collection<LogisticUnitGoodsReceipt>();

            }
            catch (Exception ex)
            {
                s_log.Error("", ex);
                if (!(ex is ProdumexException))
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "MessageKey", ex.Message,
                            "NoTranslationOfMessageKey", true,
                            "ShowButton", true));
                    WaitForMessage();

                }
                else
                {
                    // Inform the user with the error
                    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                        DefaultCultureInfo.Get(), BuildParamCollection(
                            "PmxError", ((ProdumexException)ex).Error,
                            "ShowButton", true));
                    WaitForMessage();
                }

                //ask user if he wants to try again after error
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "TitleKey", "MSG_TITLE_ERROR_TRY_AGAIN",
                        "MessageKey", "MSG_QUESTION_ERROR_TRY_AGAIN"));
                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    goto Step_ReceiveItems;
                }


                goto Step_SelectPOFilter;

            }

            goto Step_PrintDeliveryDocument;


            #endregion

        Step_PrintDeliveryDocument:

            #region PRINT DELIVERY DOCUMENT

            numberOfReports = 0;
            try
            {
                foreach (DocumentRef docRef in listOfGeneratedDocEntry.Key)
                {
                    //trigger event
                    numberOfReports += sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null, new DelegateWithPmxDbConnection<int>(ExecutePrintEvents), PmxPrintReportEventType.ReceptionPurchaseDeliveryNoteCreated, currentDockCode, deviceID, docRef.DocEntry);
                }
            }
            catch (Produmex.Foundation.ProdumexException ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", ex.Error,
                        "ShowButton", true));

                msg = WaitForMessage();
            }
            catch (Exception ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                        "ShowButton", true));

                msg = WaitForMessage();
            }

            goto Step_DocumentsPrinted;

            #endregion

        Step_DocumentsPrinted:

            #region DOCUMENTS PRINTED

            if (numberOfReports > 0)
            {
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "MessageKey", "MSG_QUESTION_REPRINT_DOCUMENT",
                        "TitleKey", "MSG_TITLE_REPRINT_DOCUMENT"));

                msg = WaitForMessage();

                if (msg.Name.EndsWith(".Yes"))
                {
                    goto Step_PrintDeliveryDocument;
                }

            }

            goto Step_GeneratePutAway;


            #endregion

        Step_GeneratePutAway:

            #region GENERATE PUT AWAY

            try
            {
                foreach (DocumentRef docRef in listOfGeneratedDocEntry.Key)
                {
                    sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null, new DelegateWithPmxDbConnection<object>(ExecuteGeneratePutAwayOrder), docRef.DocEntry, currentDockCode);
                }
            }
            catch (Produmex.Foundation.ProdumexException ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", ex.Error,
                        "ShowButton", true));

                msg = WaitForMessage();
            }
            catch (Exception ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                        "ShowButton", true));

                msg = WaitForMessage();
            }

            goto Step_MoveForLogisticUnitsWithOnlyLogicCarriers;

            #endregion

        Step_MoveForLogisticUnitsWithOnlyLogicCarriers:

            #region MOVE LOGISTIC CARRIERS

            try
            {
                sboProviderService.InvokeMethodWithDbConnection<bool>(false, false, null, null, new DelegateWithPmxDbConnection<bool>(ExecuteCreateMoveForLogisticUnitsWithOnlyLogicCarriersIfConfigured), currentDockCode);
            }
            catch (Produmex.Foundation.ProdumexException ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", ex.Error,
                        "ShowButton", true));

                msg = WaitForMessage();
            }
            catch (Exception ex)
            {
                s_log.Error(ex.ToString());
                session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
                    DefaultCultureInfo.Get(), BuildParamCollection(
                        "InitialErrorKey", initialErrorKey,
                        "MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
                        "MessageAddendum", ex.Message,
                        "PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
                        "ShowButton", true));

                msg = WaitForMessage();
            }

            //// Inform the user the items are received
            //session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
            //    DefaultCultureInfo.Get(), BuildParamCollection(
            //        "MessageKey", "MSG_ITEMS_ARE_RECEIVED",
            //        "ShowButton", true));
            //WaitForMessage();


            if (goBack)
            {
                cardCode = null;
                goBack = false;
                if (filterButtonKey == "MSG_BUTTON_PO_FILTER_NO_PO")
                {
                    goto Step_SelectPOFilter;
                }
                else if (filterButtonKey == "MSG_BUTTON_PO_FILTER_EAN")
                {
                    goto Step_FilterOnEAN;
                }
                else
                {
                    goto Step_SelectOrder;
                }
            }


            if (purchaseOrderDocEntry.HasValue)
            {
                //check if there are still items to receive
				query = BuildQuery.GetCodeNameItemsOrderByName(null, null, purchaseOrderDocEntry, cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing, true, false, sboProviderService.GetDbTool());
                dsCheckItems = sboProviderService.RunView(true, null, null, query);

                RemoveReceivedItems(purchaseDeliveryNoteList, dsCheckItems, currentLogUnit);

                if (this.GetNumberOfRows(dsCheckItems) > 0)
                {
                    //same purchase order, so enter next item
                    goto Step_ShowMessageNextLogisticUnit;
                }
            }


            goto Step_SelectPOFilter;

            #endregion


        }

        #endregion

        #region HELPERS

        private string GetTransactionalPackagingTypesText(double quantity, string uom, Collection<PackagingTypeInfo> listOfTransactionalPackagingTypes)
        {

            if (listOfTransactionalPackagingTypes == null ||
                listOfTransactionalPackagingTypes.Count == 0)
            {
                return string.Format("# {0} {1}", quantity.ToString(), uom);
            }

            //we found packagingTypes
            double currentQty = quantity;
            StringBuilder sb = new StringBuilder();
            string separator = "";
            //loop from end
            for (int iLoop = 0; iLoop < listOfTransactionalPackagingTypes.Count; iLoop++)
            {
                double qty = currentQty / listOfTransactionalPackagingTypes[iLoop].QuantityPerPack;

                qty = Math.Floor(qty);


                sb.AppendFormat("{0}{1} {2}",
                    separator, qty.ToString(), listOfTransactionalPackagingTypes[iLoop].PackagingTypeName);

                currentQty -= qty * listOfTransactionalPackagingTypes[iLoop].QuantityPerPack;

                separator = Definitions.SEPARATOR;

            }

            return sb.ToString();


        }


        private string GetQuantityInPackagingTypesText(Collection<PackagingTypeInfo> listOfTransactionalPackagingTypes)
        {

            if (listOfTransactionalPackagingTypes == null ||
                listOfTransactionalPackagingTypes.Count == 0)
            {
                return null;
            }

            //we found packagingTypes
            StringBuilder sb = new StringBuilder();
            string separator = "";

            

            for (int iLoop = 0; iLoop < listOfTransactionalPackagingTypes.Count-1; iLoop++)
            {

                sb.AppendFormat("{0}1 {1} = {2} {3}", separator, listOfTransactionalPackagingTypes[iLoop].PackagingTypeName, listOfTransactionalPackagingTypes[iLoop].QuantityPerPack / listOfTransactionalPackagingTypes[iLoop + 1].QuantityPerPack, listOfTransactionalPackagingTypes[iLoop + 1].PackagingTypeName);


                separator = Definitions.SEPARATOR;

            }

            return sb.ToString();

        }

        private static string GetPackTypeName(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
        {
            if (listOfPackagingTypes != null)
            {
                foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
                {
                    if (packType.PackagingTypeCode == packagingTypeCode)
                    {
                        return packType.PackagingTypeName;
                    }
                }
            }

            return null;
        }

		/// <summary>
		/// Gets the pack barcode.
		/// </summary>
		/// <param name="packagingTypeCode">The packaging type code.</param>
		/// <param name="listOfPackagingTypes">The list of packaging types.</param>
		/// <returns></returns>
		private static Collection<string> GetPackBarcode(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
		{
			if (listOfPackagingTypes != null)
			{
				foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
				{
					if (packType.PackagingTypeCode == packagingTypeCode)
					{
						if (packType.Barcodes.Count > 0)
						{
							return packType.Barcodes;
						}
						else
						{
							return null;
						}
					}
				}
			}

			return null;
		}

        private static bool GetHideDuringEnteringQuantity(string packagingTypeCode, Collection<PmxItemPackagingTypeInfo> listOfPackagingTypes)
        {
            if (listOfPackagingTypes != null)
            {
                foreach (PmxItemPackagingTypeInfo packType in listOfPackagingTypes)
                {
                    if (packType.PackagingTypeCode == packagingTypeCode)
                    {
                        return packType.HideDuringEnteringQuantity;
                    }
                }
            }

            return true;
        }

        /// <summary>
        /// Executes the print events.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static int ExecutePrintEvents(PmxDbConnection conn, object[] parameters)
        {
            PmxPrintReportProvider prov = new PmxPrintReportProvider(conn);
            bool askReprint;
            return prov.PrintReportsForEvent((PmxPrintReportEventType)parameters[0], (string)parameters[1], (string)parameters[2], (int)parameters[3], out askReprint);
        }


        private static int ExecuteGenerateLuid(PmxDbConnection conn, object[] parameters)
        {
            PmxLogisticUnitIDProvider logUnitProv = new PmxLogisticUnitIDProvider(conn);
            string sscc = (string)parameters[0];
            string supplierPalletNumber = (string)parameters[1];
            int logisticUnitId = -1;
            if (string.IsNullOrEmpty(sscc))
            {
                logisticUnitId = logUnitProv.GenerateNewLogisticUnit(supplierPalletNumber);
            }
            else
            {
                //generate for sscc
                logisticUnitId = logUnitProv.NewLogisticUnitID(sscc, supplierPalletNumber);
            }

            return logisticUnitId;
        }


        private static int? ExecuteGetCreateItemTransactionalInfoKey(PmxDbConnection conn, object[] parameters)
        {
            PmxItemTransactionalInfoProvider prov = new PmxItemTransactionalInfoProvider(conn);
            string itemCode = (string)parameters[0];
            string batchNumber = (string)parameters[1];
            string batchNumber2 = (string)parameters[2];
            DateTime? bbd = (DateTime?)parameters[3];

            return prov.GetCreateItemTransactionalInfoKey(itemCode, batchNumber, batchNumber2, bbd);
        }

        /// <summary>
        /// Executes the get receive all items on one purchase delivery.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteGetReceiveAllItemsOnOnePurchaseDelivery(PmxDbConnection conn, object[] parameters)
        {
            PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection) conn);

            return prov.ReceiveAllItemsOnOnePurchaseDelivery();
        }


        /// <summary>
        /// Executes the generate put away order.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static object ExecuteGeneratePutAwayOrder(PmxDbConnection conn, object[] parameters)
        {
            PmxMoveOrderProvider prov = new PmxMoveOrderProvider(conn);

            prov.GeneratePutAwayOrder((int)parameters[0], 200, null, true, (string)parameters[1]);

            return null;
        }

        /// <summary>
        /// Executes the create move for logistic units with only logic carriers if configured.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteCreateMoveForLogisticUnitsWithOnlyLogicCarriersIfConfigured(PmxDbConnection conn, object[] parameters)
        {
            PmxMoveProvider prov = new PmxMoveProvider(conn);

            return prov.CreateMoveForLogisticUnitsWithOnlyLogicCarriersIfConfigured((string)parameters[0]);
        }


        /// <summary>
        /// Executes the print reports for event collection.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static int ExecutePrintReportsForEventWithParametersCollection(PmxDbConnection conn, object[] parameters)
        {
            PmxPrintReportProvider prov = new PmxPrintReportProvider(conn);
            bool askReprint;
            return prov.PrintReportsForEventWithParametersCollection((PmxPrintReportEventType)parameters[0], (string)parameters[1], (string)parameters[2], (Collection<Dictionary<string, object>>)parameters[3], (bool)parameters[4], out askReprint);
        }

        /// <summary>
        /// Executes the print reports for event.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static int ExecutePrintReportsForEventWithParameters(PmxDbConnection conn, object[] parameters)
        {
            PmxPrintReportProvider prov = new PmxPrintReportProvider(conn);
            bool askReprint;
            return prov.PrintReportsForEventWithParameters((PmxPrintReportEventType)parameters[0], (string)parameters[1], (string)parameters[2], (Dictionary<string, object>)parameters[3], (bool)parameters[4], out askReprint);
        }

        /// <summary>
        /// Executes the add purchase delivery note list of logistic units.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private KeyValuePair<Collection<DocumentRef>, Collection<int>> ExecuteAddPurchaseDeliveryNoteListOfLogisticUnits(PmxDbConnection conn, object[] parameters)
        {
            PmxPurchaseDeliveryNoteProvider prov = new PmxPurchaseDeliveryNoteProvider((SboConnection)conn);
            return prov.AddPurchaseDeliveryNoteListOfLogisticUnits((string)parameters[0], (string)parameters[1], (Collection<LogisticUnitGoodsReceipt>)parameters[2], (string)parameters[3], null, null, null);
        }

        /// <summary>
        /// Sets the item transactional packaging type info list.
        /// </summary>
        /// <param name="itemInfo">The item info.</param>
        /// <returns></returns>
        private Collection<ItemTransactionalPackagingTypeInfo> SetItemTransactionalPackagingTypeInfoList(PmxItemInfo itemInfo)
        {
            //get the packaging types qty from item
            Collection<ItemTransactionalPackagingTypeInfo> listOfTransactionalPackagingTypeInfos = new Collection<ItemTransactionalPackagingTypeInfo>();

            foreach (PmxItemPackagingTypeInfo packInfo in itemInfo.ListOfPackagingTypes)
            {
                ItemTransactionalPackagingTypeInfo newPackInfo = new ItemTransactionalPackagingTypeInfo();

                newPackInfo.PackagingTypeCode = packInfo.PackagingTypeCode;
                newPackInfo.Quantity = packInfo.Quantity;
                newPackInfo.ItemCode = itemInfo.ItemCode;

                listOfTransactionalPackagingTypeInfos.Add(newPackInfo);

            }

            return listOfTransactionalPackagingTypeInfos;
        }


        /// <summary>
        /// Gets the transactional packaging info.
        /// </summary>
        /// <param name="purchaseDeliveryNoteList">The purchase delivery note list.</param>
        /// <param name="batchNumber">The batch number.</param>
        /// <param name="secondBatchNumber">The second batch number.</param>
        /// <param name="bestBeforeDate">The best before date.</param>
        /// <param name="itemCode">The item code.</param>
        /// <returns></returns>
        private static Collection<ItemTransactionalPackagingTypeInfo> GetTransactionalPackagingInfo(Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList, string batchNumber, string secondBatchNumber, DateTime? bestBeforeDate, string itemCode)
        {
            //does it exist in the just received items?
            foreach (LogisticUnitGoodsReceipt receipt in purchaseDeliveryNoteList)
            {
                foreach (LogisticUnitItemGoodReceipt receiptItem in receipt.ItemsOnLogisticUnit)
                {
                    if (batchNumber == receiptItem.BatchNumber1 &&
                        secondBatchNumber == receiptItem.BatchNumber2 &&
                        bestBeforeDate == receiptItem.BestBeforeDate &&
                        itemCode == receiptItem.ItemCode)
                    {
                        //we found the packagingData
                        return receiptItem.ListOfPackagingTypes;
                    }
                }
            }
            return null;
        }

        private static GeneratedBatchNumberReception ExecuteGenerateBatchNumber1ForReception(PmxDbConnection conn, object[] parameters)
        {
            PmxBatchNumberReceptionProvider prov = new PmxBatchNumberReceptionProvider(conn);
            Produmex.Foundation.Data.Sbo.DataObjects.DocumentRef docRef = ((int?)parameters[0]).HasValue? new Produmex.Foundation.Data.Sbo.DataObjects.DocumentRef( SboObjectType.PurchaseOrder, ((int?)parameters[0]).Value):null;
            if ((bool)parameters[4])
            {
                return prov.GenerateBatchNumber1ForReception(docRef, (int?)parameters[1], (string)parameters[2], (string)parameters[3]);
            }
            else
            {
                return prov.GenerateBatchNumber2ForReception(docRef, (int?)parameters[1], (string)parameters[2], (string)parameters[3]);
            }
        }


        /// <summary>
        /// Removes the received items.
        /// </summary>
        /// <param name="purchaseDeliveryNoteList">The purchase delivery note list.</param>
        /// <param name="dsProducts">The ds products.</param>
        private void RemoveReceivedItems(Collection<LogisticUnitGoodsReceipt> purchaseDeliveryNoteList, DataSet dsProducts, LogisticUnitGoodsReceipt currentUnit)
        {
            foreach (LogisticUnitGoodsReceipt logUnit in purchaseDeliveryNoteList)
            {
                foreach (LogisticUnitItemGoodReceipt logUnitItem in logUnit.ItemsOnLogisticUnit)
                {
                    if (dsProducts != null &&
                        dsProducts.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME))
                    {
                        DataRow[] rows = dsProducts.Tables[0].Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + logUnitItem.ItemCode + "'");
                        double alreadyReceived = logUnitItem.Quantity;
                        for (int iLoop = 0; iLoop < rows.Length; iLoop++)
                        {
                            if (alreadyReceived <= 0)
                            {
                                break;
                            }
                            double stillToReceive = Convert.ToInt32(rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME]);

                            double qtyReduced = 0;

                            if (stillToReceive <= alreadyReceived)
                            {
                                //no more quantity to receive, so delete the entry
                                rows[iLoop].Delete();
                                qtyReduced = stillToReceive;
                            }
                            else
                            {
                                //reduce the quantity
                                rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME] = stillToReceive - alreadyReceived;
                                qtyReduced = alreadyReceived;

                            }

                            alreadyReceived -= qtyReduced;
                        }
                        dsProducts.AcceptChanges();
                    }
                }
            }

            if (currentUnit != null)
            {
                foreach (LogisticUnitItemGoodReceipt logUnitItem in currentUnit.ItemsOnLogisticUnit)
                {
                    if (dsProducts != null &&
                        dsProducts.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME))
                    {
                        DataRow[] rows = dsProducts.Tables[0].Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + logUnitItem.ItemCode + "'");
                        double alreadyReceived = logUnitItem.Quantity;
                        for (int iLoop = 0; iLoop < rows.Length; iLoop++)
                        {
                            double stillToReceive = Convert.ToInt32(rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME]);
                            if (stillToReceive <= alreadyReceived)
                            {
                                //no more quantity to receive, so delete the entry
                                rows[iLoop].Delete();
                            }
                            else
                            {
                                //reduce the quantity
                                rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME] = stillToReceive - alreadyReceived;
                            }
                        }
                        dsProducts.AcceptChanges();
                    }
                }
            }

        }

        /// <summary>
        /// Gets the still to receive.
        /// </summary>
        /// <param name="dsProducts">The ds products.</param>
        /// <param name="itemCode">The item code.</param>
        /// <returns></returns>
        private double GetStillToReceive(DataSet dsProducts, string itemCode)
        {
            double stillToReceive = 0;
            if (dsProducts != null &&
                    dsProducts.Tables[0].Columns.Contains(SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME))
            {
                DataRow[] rows = dsProducts.Tables[0].Select(ProductDataSet.Columns.PRODUCT_CODE.Name + "= '" + itemCode + "'");
                stillToReceive = 0;
                for (int iLoop = 0; iLoop < rows.Length; iLoop++)
                {
                    stillToReceive += Convert.ToDouble(rows[iLoop][SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME]);
                }
            }
            return stillToReceive;
        }




        /// <summary>
        /// Executes the can item be stored on storage location.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteCanItemBeStoredOnStorageLocation(PmxDbConnection conn, object[] parameters)
        {
            PmxOseStorageLocationProvider prov = new PmxOseStorageLocationProvider(conn);
            return prov.CanItemBeStoredOnStorageLocation((string)parameters[1], (string)parameters[0], null);
        }

        /// <summary>
        /// Executes the is SSCC valid.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteIsSSCCValid(PmxDbConnection conn, object[] parameters)
        {
            PmxSSCCProvider ssccProv = new PmxSSCCProvider(conn);
            return ssccProv.IsValidChecksumSSCC((string)parameters[0]);
        }

        /// <summary>
        /// Executes the get LUID by SSCC.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static int ExecuteGetLUIDBySSCC(PmxDbConnection conn, object[] parameters)
        {
            PmxLogisticUnitIDProvider prov = new PmxLogisticUnitIDProvider(conn);
            return prov.GetLUIDBySSCC((string)parameters[0]);
        }

        /// <summary>
        /// Executes the get SSCC by LUID.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static string ExecuteGetSSCCByLUID(PmxDbConnection conn, object[] parameters)
        {
            PmxLogisticUnitIDProvider prov = new PmxLogisticUnitIDProvider(conn);
            return prov.GetSSCCByLUID((int)parameters[0]);
        }

        /// <summary>
        /// Gets the number of rows.
        /// </summary>
        /// <param name="ds">The ds.</param>
        /// <returns></returns>
        private int GetNumberOfRows(DataSet ds)
        {
            if (ds != null &&
                ds.Tables.Count > 0)
            {
                return ds.Tables[0].Rows.Count;
            }

            return 0;
        }

        /// <summary>
        /// Checks if there are Products the on barcode.
        /// </summary>
        /// <param name="BarcodeContainerObject">The barcode container object.</param>
        /// <returns>
        /// True, if there is a product on the barcode, false if not
        /// </returns>
        public bool IsProductOnBarcode(BarcodeContainer BarcodeContainerObject)
        {
            if (BarcodeContainerObject != null &&
                !string.IsNullOrEmpty(BarcodeHelper.GetProductIdentification(BarcodeContainerObject)))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is a LU the on barcode.
        /// </summary>
        /// <param name="barcodeContainerObject">The barcode container object.</param>
        /// <returns>
        /// True, if there is a LU on the barcode, false if not
        /// </returns>
        public bool IsLUOnBarcode(BarcodeContainer barcodeContainerObject)
        {
            if (barcodeContainerObject != null &&
                barcodeContainerObject.GS1DataObject != null &&
                barcodeContainerObject.GS1DataObject.GTINLU != null)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is an SSCC the on barcode.
        /// </summary>
        /// <param name="GS1DataScanned">The G s1 data scanned.</param>
        /// <returns>
        /// True, if there is an sscc on the barcode, false if not
        /// </returns>
        public bool IsSSCCOnBarcode(GS1Data GS1DataScanned)
        {
            if (GS1DataScanned != null &&
                (GS1DataScanned.Sscc != null))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is a best before Date the on barcode.
        /// </summary>
        /// <param name="GS1DataScanned">The G s1 data scanned.</param>
        /// <returns>
        /// True, if there is an best before date on the barcode, false if not
        /// </returns>
        public bool IsBestBeforeDateOnBarcode(GS1Data GS1DataScanned)
        {
            if (GS1DataScanned != null &&
                (GS1DataScanned.BestBeforeDate != null))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is a quantity the on barcode.
        /// </summary>
        /// <param name="GS1DataScanned">The G s1 data scanned.</param>
        /// <returns>
        /// True, if there is a quantity on the barcode, false if not
        /// </returns>
        public bool IsQuantityOnBarcode(BarcodeContainer barcode)
        {
            if (barcode != null &&
            barcode.GS1DataObject != null &&
                barcode.GS1DataObject.Count != null)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// Checks if there is a batch number the on barcode.
        /// </summary>
        /// <param name="GS1DataScanned">The G s1 data scanned.</param>
        /// <returns>
        /// True, if there is a batch number on the barcode, false if not
        /// </returns>
        public bool IsBatchNumberOnBarcode(GS1Data GS1DataScanned)
        {
            if (GS1DataScanned != null &&
                (GS1DataScanned.LotNumber != null))
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// Executes the get item info.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static PmxItemInfo ExecuteGetItemInfo(PmxDbConnection conn, object[] parameters)
        {
            PmxItemAllConnectionsProvider prov = new PmxItemAllConnectionsProvider(conn);
            return prov.GetItemInfo((string)parameters[0]);
        }


        /// <summary>
        /// Executes the get PMX warehouse code.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static PmxOseWarehouseInfo ExecuteGetPmxWarehouseCode(PmxDbConnection conn, object[] parameters)
        {
            PmxOseProvider oseProv = new PmxOseProvider(conn);
            return oseProv.GetPmxWarehouseInfo((string)parameters[0]);
        }

        /// <summary>
        /// Executes the need to enter supplier pallet number.
        /// </summary>
        /// <param name="conn">The conn.</param>
        /// <param name="parameters">The parameters.</param>
        /// <returns></returns>
        private static bool ExecuteNeedToEnterSupplierPalletNumber(PmxDbConnection conn, object[] parameters)
        {
            PmxBusinessPartnerProvider prov = new PmxBusinessPartnerProvider((SboConnection)conn);
            return prov.NeedToEnterSupplierPalletNumber((string)parameters[0]);
        }




        #endregion

        #region BUILD QUERY

        /// <summary>
        /// Static class grouping our native queries
        /// </summary>
        internal static class BuildQuery
        {
            private static SboBooleanConvertor m_sboBooleanConvertor = null;
            private static SboBooleanConvertor BooleanConvertor
            {
                get
                {
                    if (m_sboBooleanConvertor == null)
                    {
                        m_sboBooleanConvertor = new SboBooleanConvertor();
                    }
                    return m_sboBooleanConvertor;
                }
            }

            /// <summary>
            /// Gets the name and the code of the  location, ordered by name.
            /// </summary>
            /// <param name="isLoading">Is the dock for loading? When null, no check will be done on this value</param>
            /// <param name="isUnloading">Is the dock for unloading? When null, no check will be done on this value</param>
            /// <param name="useAnd">if set to <c>true</c> the operand between Loading and Unloading is 'AND'.
            /// Otherwise it is 'OR'.</param>
            /// <param name="pmxWarehouseCode">The PMX warehouse code.</param>
            /// <returns>The sql statement to get the dock</returns>
            public static string GetCodeNameDockOrderByName(bool? isLoading, bool? isUnloading, bool useAnd, string pmxWarehouseCode)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME, LocationDataSet.Columns.CODE.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Name.NAME, LocationDataSet.Columns.DESCRIPTION.Name);
                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME, LocationDataSet.Columns.WAREHOUSECODE.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Name.NAME, LocationDataSet.Columns.WAREHOUSENAME.Name);


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseDockTable.NAME));

                //inner join PmxOseDock - PmxOse
                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);

                //inner join PmxOseDock - PmxOseStorageLocation
                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseStorageLocationGeneralTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Code.NAME);

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseWarehouseTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Code.NAME);


                strBuilder.Append(" WHERE ");

                //Dock must be active
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.IsActive.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                if (!string.IsNullOrEmpty(pmxWarehouseCode))
                {
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(pmxWarehouseCode, CultureInfo.InvariantCulture));
                }

                if (isUnloading.HasValue)
                {
                    strBuilder.Append(" AND ");

                    //group when both have a value
                    if (isUnloading.HasValue &&
                        isLoading.HasValue)
                    {
                        strBuilder.Append(" ( ");
                    }

                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.IsUnloadingDock.NAME);
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(BooleanConvertor.ConvertBOPropertyToColumn(isUnloading.Value), CultureInfo.InvariantCulture));
                }

                if (isLoading.HasValue)
                {
                    if (useAnd)
                    {
                        strBuilder.Append(" AND ");
                    }
                    else
                    {
                        strBuilder.Append(" OR ");
                    }
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.IsLoadingDock.NAME);
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(BooleanConvertor.ConvertBOPropertyToColumn(isLoading.Value), CultureInfo.InvariantCulture));

                    //group when both have a value
                    if (isUnloading.HasValue &&
                        isLoading.HasValue)
                    {
                        strBuilder.Append(" ) ");
                    }
                }

                strBuilder.Append(" ORDER BY ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseDockTable.NAME, PmxOseDockTable.Columns.Name.NAME);

                return strBuilder.ToString();
            }

			//public static string GetAllPackagingTypes()
			//{
			//    StringBuilder strBuilder = new StringBuilder();
			//    strBuilder.Append("SELECT ");

			//    SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPackagingTypeTable.NAME, PmxPackagingTypeTable.Columns.Code.NAME, PmxPackagingTypeTable.Columns.Code.NAME);
			//    strBuilder.Append(", ");
			//    SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxPackagingTypeTable.NAME, PmxPackagingTypeTable.Columns.Name.NAME, PmxPackagingTypeTable.Columns.Name.NAME);

			//    strBuilder.Append(" FROM ");
			//    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxPackagingTypeTable.NAME));

			//    return strBuilder.ToString();
			//}


			/// <summary>
			/// Command for getting all PO's order by PO Number
			/// </summary>
			/// <param name="cardCode">The card code.</param>
			/// <param name="gtin">The gtin.</param>
			/// <param name="dbTool">The database tool.</param>
			/// <returns>
			/// Command for getting all PO's order by PO Number
			/// </returns>
            public static string GetPOsOrderByPONumber(string cardCode, string gtin, DbTool dbTool)
            {
                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.Append("SELECT DISTINCT ");



                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.DocNum.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(PurchaseOrderDataSet.Columns.PO_NUMBER.Name);

                strBuilder.Append(", CAST(");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.DocNum.NAME));
                strBuilder.Append(" AS NVARCHAR) AS ");
                strBuilder.Append(PurchaseOrderDataSet.Columns.PO_NUMBER_ASSTRING.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.CardName.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(PurchaseOrderDataSet.Columns.SUPPLIER_NAME.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.CardCode.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(PurchaseOrderDataSet.Columns.SUPPLIER_CODE.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.DocEntry.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(PurchaseOrderDataSet.Columns.PO_ID.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.NumAtCard.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(PurchaseOrderDataSet.Columns.SUPPLIER_REFERENCE.Name);

                strBuilder.Append( ", " );
                strBuilder.Append( SqlCommandHelper.EscapeTableName( PmxPurchaseOrderLineTable.NAME ) );
                strBuilder.Append( "." );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( PmxPurchaseOrderLineTable.Columns.SupplierLineRef.NAME ) );
                strBuilder.Append( " AS " );
                strBuilder.Append( PurchaseOrderDataSet.Columns.SUPPLIER_LINE_REF.Name );

                strBuilder.AppendFormat(", {0}",
                SqlCommandHelper.EscapeTableColumnNameWithAlias(SboPurchaseOrderTable.NAME, "ObjType", PurchaseOrderDataSet.Columns.DOC_OBJ_TYPE.Name));



                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));

                strBuilder.Append( " INNER JOIN " );
                strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderLineTable.NAME ) );
                strBuilder.Append( " ON " );
                SqlCommandHelper.AddTableColumnName( strBuilder, SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.DocEntry.NAME );
                strBuilder.Append( " = " );
                SqlCommandHelper.AddTableColumnName( strBuilder, SboPurchaseOrderLineTable.NAME, SboPurchaseOrderLineTable.Columns.DocEntry.NAME );

                
                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, SboPurchaseOrderLineTable.NAME, SboPurchaseOrderLineTable.Columns.ItemCode.NAME);
                
                strBuilder.Append(" WHERE ");

                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.DocStatus.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));
                
                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.Canceled.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));


                if (cardCode != null &&
                    cardCode.Trim() != "")
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.CardCode.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(cardCode, CultureInfo.InvariantCulture));
                }

                if (gtin != null &&
                    gtin.Trim() != "")
                {
                    strBuilder.Append(" AND ");
                    Produmex.Sbo.Logex.Data.SboCommands.AddWhereClauseSearchForBarcodePackagingType(strBuilder, gtin);
                }

                //only for open lines
                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderLineTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderLineTable.Columns.LineStatus.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture));

                //only approved orders
                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboPurchaseOrderTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.Confirmed.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));


                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboPurchaseOrderTable.Columns.DocNum.NAME));
                return strBuilder.ToString();
            }

            /// <summary>
            /// Gets the existing ITRI.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <param name="batchNumber">The batch number.</param>
            /// <param name="batchNumber2">The batch number2.</param>
            /// <param name="bestBeforeDate">The best before date.</param>
            /// <returns></returns>
            public static string GetExistingITRI(string itemCode, string batchNumber, string batchNumber2, DateTime? bestBeforeDate)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.PackagingTypeCode.NAME));

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME));


                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));

                strBuilder.Append(" ON ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.ItemTransactionalInfoKey.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));



                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.ItemCode.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));

                if (!string.IsNullOrEmpty(batchNumber))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(batchNumber, CultureInfo.InvariantCulture));
                }

                if (!string.IsNullOrEmpty(batchNumber2))
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(batchNumber2, CultureInfo.InvariantCulture));
                }

                if (bestBeforeDate.HasValue)
                {
                    strBuilder.Append(" AND ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                    strBuilder.Append(".");
                    strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME));
                    strBuilder.Append(" = ");
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(bestBeforeDate.Value, CultureInfo.InvariantCulture));
                }

                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalPackagingTypeTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalPackagingTypeTable.Columns.Quantity.NAME));


                return strBuilder.ToString();
            }


            /// <summary>
            /// Command for getting all suppliers order by name
            /// </summary>
            /// <returns>Command for getting all suppliers order by name</returns>
            public static string GetSuppliersOrderByName()
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboBusinessPartnerTable.Columns.CardCode.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(SupplierDataSet.Columns.SUPPLIER_CODE.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboBusinessPartnerTable.Columns.CardName.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(SupplierDataSet.Columns.SUPPLIER_NAME.Name);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboBusinessPartnerTable.NAME));

                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboBusinessPartnerTable.Columns.CardType.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBusinessPartnerTypeColumnValues.Vendor.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboBusinessPartnerTable.Columns.CardName.NAME));
                return strBuilder.ToString();
            }


			/// <summary>
			/// Command for getting all products order by name
			/// </summary>
			/// <param name="vendorCode">The vendor code.</param>
			/// <param name="gtin">The gtin.</param>
			/// <param name="poDocEntry">The po doc entry.</param>
			/// <param name="cardCode">The card code.</param>
			/// <param name="packagingUnit">The packaging unit.</param>
			/// <param name="filterOutFrozenItems">if set to <c>true</c> [filter out frozen items].</param>
			/// <param name="distinct">if set to <c>true</c> [distinct].</param>
			/// <param name="dbTool">The database tool.</param>
			/// <returns>
			/// Command for getting all products order by name
			/// </returns>
            public static string GetCodeNameItemsOrderByName( string vendorCode, string gtin, int? poDocEntry, string cardCode, Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit packagingUnit, bool filterOutFrozenItems, bool distinct, DbTool dbTool )
            {
				DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.Append( "SELECT " );
                if (distinct)
                {
                    strBuilder.Append(" DISTINCT ");
                }

                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.NAME ) );
                strBuilder.Append( "." );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.Columns.ItemCode.NAME ) );
                strBuilder.Append( " AS " );
                strBuilder.Append( ProductDataSet.Columns.PRODUCT_CODE.Name );



                strBuilder.Append( ",  CASE" );
                if ( poDocEntry.HasValue || !String.IsNullOrEmpty( cardCode ) )
                {
                    strBuilder.AppendFormat(" WHEN {0} <> '' THEN {0} + ' - ' + {1} + ' - ' + {2} ",
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.SubstituteItemDescr.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME),
                        SqlCommandHelper.EscapeTableColumnName(PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.Substitute.NAME));
                }
                strBuilder.AppendFormat(" WHEN {0} <> '' THEN {0} + ' - ' + {1} ",
                    SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.VendorItemDescr.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME));
                strBuilder.AppendFormat( " ELSE {0} END",
                    SqlCommandHelper.EscapeTableColumnName( PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME ) );
                strBuilder.Append( " AS " );
                strBuilder.Append( ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name );

                strBuilder.Append( ", " );
                Produmex.Sbo.Logex.Data.SboCommands.AddBarcodeUsingPackagingUnit( strBuilder, packagingUnit, ProductDataSet.Columns.GTIN.Name );

                strBuilder.Append( ", " );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.NAME ) );
                strBuilder.Append( "." );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( PmxItemTable.Columns.HasBestBeforeDate.NAME ) );

                strBuilder.Append( ", " );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( PmxItemTable.NAME ) );
                strBuilder.Append( "." );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( PmxItemTable.Columns.PrintItemLabelReception.NAME ) );


                strBuilder.Append( ", " );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.NAME ) );
                strBuilder.Append( "." );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.Columns.ManBtchNum.NAME ) );

                strBuilder.Append( ", " );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.NAME ) );
                strBuilder.Append( "." );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( PmxItemTable.Columns.IsLogisticUnit.NAME ) );

                strBuilder.Append( ", " );
                SqlCommandHelper.AddTableColumnName( strBuilder, SboItemTable.NAME, SboItemTable.Columns.NumberOfItemsPerPurchaseUnit.NAME );

                strBuilder.Append( ", " );
                SqlCommandHelper.AddTableColumnName( strBuilder, SboItemTable.NAME, SboItemTable.Columns.PurchaseUom.NAME );

                strBuilder.Append( ", " );
                SqlCommandHelper.AddTableColumnName( strBuilder, SboItemTable.NAME, SboItemTable.Columns.InventoryUom.NAME );

                strBuilder.Append( ", " );
                Produmex.Sbo.Logex.Data.SboCommands.AddBarcodeUsingPackagingUnit( strBuilder, packagingUnit, SboItemTable.Columns.CodeBars.NAME );
                //SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.PurchaseBarcode.NAME);

                if ( poDocEntry.HasValue && ! distinct)
                {
                    strBuilder.Append( ", " );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboPurchaseOrderLineTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboPurchaseOrderLineTable.Columns.OpenCreQty.NAME ) );

                    strBuilder.Append( ", " );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboPurchaseOrderLineTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboPurchaseOrderLineTable.Columns.QuantityPerUom.NAME ) );
                }

                strBuilder.Append( ", " );
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ItemName.NAME));

                strBuilder.Append( " FROM " );
                strBuilder.Append( SqlCommandHelper.EscapeTableName( SboItemTable.NAME ) );

                if ( poDocEntry.HasValue )
                {
                    //inner join Product - PO Line
                    strBuilder.Append( " INNER JOIN " );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderLineTable.NAME ) );
                    strBuilder.Append( " ON " );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderLineTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderLineTable.Columns.ItemCode.NAME ) );
                    strBuilder.Append( " = " );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboItemTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboItemTable.Columns.ItemCode.NAME ) );

                    //inner join PO - PO Line
                    strBuilder.Append( " INNER JOIN " );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderTable.NAME ) );
                    strBuilder.Append( " ON " );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderTable.Columns.DocEntry.NAME ) );
                    strBuilder.Append( " = " );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderLineTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( SboPurchaseOrderLineTable.Columns.DocEntry.NAME ) );

                    strBuilder.Append( " LEFT JOIN " );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( PmxAlternateCatNumTable.NAME ) );
                    strBuilder.AppendFormat( " ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName( PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.CardCode.NAME ),
                        SqlCommandHelper.EscapeTableColumnName( SboPurchaseOrderTable.NAME, SboPurchaseOrderTable.Columns.CardCode.NAME ) );
                    strBuilder.AppendFormat( " AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName( PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.ItemCode.NAME ),
                        SqlCommandHelper.EscapeTableColumnName( SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME ) );
                }
                else if ( !String.IsNullOrEmpty( cardCode ) )
                {
                    strBuilder.Append( " LEFT JOIN " );
                    strBuilder.Append( SqlCommandHelper.EscapeTableName( PmxAlternateCatNumTable.NAME ) );
                    strBuilder.AppendFormat( " ON {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName( PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.CardCode.NAME ),
                        SqlCommandHelper.FormatAndEscapeColumnValue( cardCode, CultureInfo.InvariantCulture ) );
                    strBuilder.AppendFormat( " AND {0} = {1}",
                        SqlCommandHelper.EscapeTableColumnName( PmxAlternateCatNumTable.NAME, PmxAlternateCatNumTable.Columns.ItemCode.NAME ),
                        SqlCommandHelper.EscapeTableColumnName( SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME ) );
                }

                string operand = " WHERE ";
                if ( !string.IsNullOrEmpty( vendorCode ) )
                {
                    strBuilder.Append( operand );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.Columns.CardCode.NAME ) );
                    strBuilder.Append( " = " );
                    strBuilder.Append( SqlCommandHelper.FormatAndEscapeColumnValue( vendorCode, CultureInfo.InvariantCulture ) );
                    operand = " AND ";
                }


                if ( !string.IsNullOrEmpty( gtin ) )
                {
                    strBuilder.Append( operand );
                    Produmex.Sbo.Logex.Data.SboCommands.AddWhereClauseSearchForBarcodePackagingType( strBuilder, gtin );
                    operand = " AND ";
                }

                if ( poDocEntry.HasValue )
                {
                    strBuilder.Append( operand );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboPurchaseOrderTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboPurchaseOrderTable.Columns.DocEntry.NAME ) );
                    strBuilder.Append( " = " );
                    strBuilder.Append( SqlCommandHelper.FormatAndEscapeColumnValue( poDocEntry.Value, CultureInfo.InvariantCulture ) );
                    operand = " AND ";

                    strBuilder.Append( operand );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboPurchaseOrderLineTable.NAME ) );
                    strBuilder.Append( "." );
                    strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboPurchaseOrderLineTable.Columns.LineStatus.NAME ) );
                    strBuilder.Append( " = " );
                    strBuilder.Append( SqlCommandHelper.FormatAndEscapeColumnValue( SboDocStatusColumnValues.Open.VALUE, CultureInfo.InvariantCulture ) );
                    operand = " AND ";

                }

                strBuilder.Append( operand );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.NAME ) );
                strBuilder.Append( "." );
                strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.Columns.InventoryItem.NAME ) );
                strBuilder.Append( " = " );
                strBuilder.Append( SqlCommandHelper.FormatAndEscapeColumnValue( SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture ) );
                operand = " AND ";

                switch ( packagingUnit )
                {
                    case Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Purchasing:
                        strBuilder.Append( operand );
                        SqlCommandHelper.AddTableColumnName( strBuilder, SboItemTable.NAME, SboItemTable.Columns.PurchaseItem.NAME );
                        strBuilder.Append( " = " );
                        strBuilder.Append( SqlCommandHelper.FormatAndEscapeColumnValue( SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture ) );
                        operand = " AND ";
                        break;
                    case Produmex.Sbo.Logex.Data.SboCommands.PackagingUnit.Sales:
                        strBuilder.Append( operand );
                        SqlCommandHelper.AddTableColumnName( strBuilder, SboItemTable.NAME, SboItemTable.Columns.SalesItem.NAME );
                        strBuilder.Append( " = " );
                        strBuilder.Append( SqlCommandHelper.FormatAndEscapeColumnValue( SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture ) );
                        operand = " AND ";
                        break;
                    default:
                        strBuilder.Append( operand );
                        SqlCommandHelper.AddTableColumnName( strBuilder, SboItemTable.NAME, SboItemTable.Columns.InventoryItem.NAME );
                        strBuilder.Append( " = " );
                        strBuilder.Append( SqlCommandHelper.FormatAndEscapeColumnValue( SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture ) );
                        operand = " AND ";
                        break;
                }

                if ( filterOutFrozenItems )
                {
                    Logex.Data.SboCommands.GetFrozenItemFilterSQLWherePart( strBuilder, " AND ");
                }

                strBuilder.Append( " ORDER BY " );
                //strBuilder.Append( SqlCommandHelper.EscapeColumnName( SboItemTable.NAME ) );
                //strBuilder.Append( "." );
                //strBuilder.Append( SqlCommandHelper.EscapeColumnName( PmxItemTable.Columns.CustomItemDescr.NAME ) );
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name));
                return strBuilder.ToString();
            }

			/// <summary>
			/// Command for getting all logistic carriers order by name
			/// </summary>
			/// <param name="onlyInStock">if set to <c>true</c> the system will get the logistic carriers that are in stock and have no products on it (LUID IS NULL)</param>
			/// <param name="filterOutFrozenItems">if set to <c>true</c> [filter out frozen items].</param>
			/// <param name="dbTool">The database tool.</param>
			/// <returns>
			/// Command for getting all logistic carriers order by name
			/// </returns>
            public static string GetLogisticCarriersOrderByName(bool onlyInStock, bool filterOutFrozenItems, DbTool dbTool)
            {

                DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.ItemCode.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(ProductDataSet.Columns.PRODUCT_CODE.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.CustomItemDescr.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(ProductDataSet.Columns.PRODUCT_DESCRIPTION.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.CodeBars.NAME));
                strBuilder.Append(" AS ");
                strBuilder.Append(ProductDataSet.Columns.GTIN.Name);

                strBuilder.Append(", ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.IsLogisticCarrier.NAME));



                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(SboItemTable.NAME));

                if (onlyInStock)
                {
                    strBuilder.Append(" INNER JOIN ");
                    strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                    strBuilder.Append(" ON ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME);
                    strBuilder.Append(" = ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME);
                    strBuilder.Append(" AND ");
                    SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME);
                    strBuilder.Append(" IS NULL ");
                }




                strBuilder.Append(" WHERE ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.Columns.InventoryItem.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.IsLogisticCarrier.NAME));
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

                if (filterOutFrozenItems)
                {
                    Logex.Data.SboCommands.GetFrozenItemFilterSQLWherePart(strBuilder, " AND ");
                }


                strBuilder.Append(" ORDER BY ");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(SboItemTable.NAME));
                strBuilder.Append(".");
                strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTable.Columns.CustomItemDescr.NAME));
                return strBuilder.ToString();

            }


            /// <summary>
            /// Gets the locked stock for base order.
            /// </summary>
            /// <param name="itemCodes">The item codes.</param>
            /// <param name="purchaseDocEntry">The purchase doc entry.</param>
            /// <returns></returns>
            public static string GetLockedStockForBaseOrder(Collection<string> itemCodes, int purchaseDocEntry)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT DISTINCT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.SSCC.NAME, SSCCDataSet.Columns.SSCC.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME, SSCCDataSet.Columns.LUID.Name);

                strBuilder.Append(", ");
                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME, SSCCDataSet.Columns.STORAGE_LOCATION_CODE.Name);

                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME, SSCCDataSet.Columns.PMX_WAREHOUSE_CODE.Name));

                strBuilder.AppendFormat(", {0}",
                    SqlCommandHelper.EscapeTableColumnNameWithAlias(PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Name.NAME, SSCCDataSet.Columns.PMX_WAREHOUSE_NAME.Name));


                
                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxPurchaseOrderLineTable.NAME));

                
                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryLockingDetailTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseType.NAME);
                strBuilder.Append(" = CAST(");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseType.NAME);
                strBuilder.Append(" AS nvarchar(20)) AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.BaseEntry.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.BaseEntry.NAME);

                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryLockingDetailTable.NAME, PmxInventoryLockingDetailTable.Columns.LogUnitIdentKey.NAME);


                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME));


                strBuilder.AppendFormat("\r\n INNER JOIN {0}",
                    SqlCommandHelper.EscapeTableName(PmxOseWarehouseTable.NAME));
                strBuilder.AppendFormat(" ON {0} = {1}",
                    SqlCommandHelper.EscapeTableColumnName(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME),
                    SqlCommandHelper.EscapeTableColumnName(PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Code.NAME));



                strBuilder.Append(" WHERE ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.DocEntry.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(purchaseDocEntry, CultureInfo.InvariantCulture));

                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxPurchaseOrderLineTable.NAME, PmxPurchaseOrderLineTable.Columns.ItemCode.NAME);
                strBuilder.Append(" IN ( ");
                string separator = "";
                foreach (string itemCode in itemCodes)
                {
                    strBuilder.Append(separator);
                    strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));
                    separator = ", ";
                }
                strBuilder.Append(" ) ");


                strBuilder.Append(" ORDER BY ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME);


                return strBuilder.ToString();

            }




            /// <summary>
            /// Gets the stock with later BBD.
            /// </summary>
            /// <param name="itemCode">The item code.</param>
            /// <param name="bbd">The BBD.</param>
            /// <returns></returns>
            public static string GetStockWithLaterBBD(string itemCode, DateTime bbd)
            {
                StringBuilder strBuilder = new StringBuilder();
                strBuilder.Append("SELECT ");

                SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME);

                strBuilder.Append(" FROM ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));


                strBuilder.Append(" INNER JOIN ");
                strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
                strBuilder.Append(" ON ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
                strBuilder.Append(" = ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);

                strBuilder.Append(" WHERE ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME);
                strBuilder.Append(" = ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));


                strBuilder.Append(" AND ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME);
                strBuilder.Append(" > ");
                strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboHelper.ConvertDateToSboDate(bbd), CultureInfo.InvariantCulture));




                strBuilder.Append(" ORDER BY ");
                SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME);
                strBuilder.Append(" DESC ");


                return strBuilder.ToString();

            }




        }

        #endregion

    }


}
